<?php
	$require_user_or_exit = true;
	require '../include/config.php';

	// This defines every step, and the fields for every step,
	// excluding step 4 and 6, which are handled elsewhere

	$step_fields = array(
		'1' => array(
			'street_address',
			'apt',
			'city',
			'state',
			'zipcode',
			'energy_goals'
		),

		'2' => array(
			'house_type',
			'size_sqft',
			'num_rooms',
			'has_basement'
		),

		'3' => array(
			'utility_provider',
			'kwh_consumption',
			'average_electric_bill'
		),

		'4' => array(),

		'5' => array(
			'central_air',
			'central_air_make',
			'central_air_make_usedd',
			'central_air_model',
			'central_air_model_usedd',
			'central_air_model_no',
			'central_air_model_no_usedd',
			'central_air_energystar',		
			'central_air_btu',
			'regular_ac_units',
			'heating_type',
			'heating_make',
			'heating_make_usedd',
			'heating_model',
			'heating_model_usedd',
			'heating_model_no',
			'heating_model_no_usedd',
			'heating_energystar',
			'heating_btu',
			'water_heater_type',
			'water_heater_make',
			'water_heater_make_usedd',
			'water_heater_model',
			'water_heater_model_usedd',
			'water_heater_model_no',
			'water_heater_model_no_usedd',
			'water_heater_energystar',
			'water_heater_btu'
		),


		'6' => array(),

		'7' => array(
			'insulation_type',
			'is_weatherproofed'
		)
	);
	
	$number_fields = array(
		'size_sqft', 'num_rooms', 'kwh_consumption', 'average_electric_bill', 'central_air_btu', 'regular_ac_units'
	);

	function show_errors() { 	
		global $show_errors;
		if(count($show_errors) == 0) return;
		foreach($show_errors as $e) {
 			echo "\$('#" . $e . "_error').css('visibility', 'visible'); ";
 		}
 	}


	// find what step we're currently displaying
	if(is_numeric($_REQUEST['step'])) {
		$step = $_REQUEST['step'];
	}

	// junk out default values
	foreach($_REQUEST as $k => $v) { 
		if($v == 'Enter Model Number...' || $v == 'Enter Make...' || $v == 'Enter Model...') {
			$_REQUEST[$k] = '';
		}
	}
	
	$req_fields[1] = array('street_address', 'city', 'state', 'zipcode');
	$req_fields[2] = array('house_type', 'size_sqft', 'num_rooms');
	$req_fields[3] = array('utility_provider', 'kwh_consumption', 'average_electric_bill');

	$show_errors = array();
	if(isset($_REQUEST['submitting_step'])) {
		$submitting_step = $_REQUEST['submitting_step'];

		if($submitting_step == 1 || $submitting_step == 2 || $submitting_step == 3) { 
			foreach($req_fields[$submitting_step] as $f) { 
				$v = trim($_REQUEST[$f]);
				if(empty($v)) { 
					$show_errors[] = $f;
					if($step > $submitting_step) { 
						$step = $submitting_step;
					}
				}
			}
		}
	}

	if(count($show_errors) != 0) { 
		echo "<script>profileUpdateStep($step);</script>";
	}

	// preselect data
	$q = $sql->query("SELECT * FROM energy_profile WHERE user_id = " . smartq($_SESSION['user_id']));
		if(mysql_num_rows($q) == 0) {
			$sql->fromarray('insert', 'energy_profile', array('user_id' => $_SESSION['user_id']));
			$form_prefill = array();
		} else { 
			$form_prefill = mysql_fetch_assoc($q);
		}
	
	// this updates the energy profile from the previous submit
	if(isset($_REQUEST['submitting_step']) && $_REQUEST['submitting_step'] != 4 && $_REQUEST['submitting_step'] != 6) {

		if($_REQUEST['submitting_step'] == 5) { 
			$dropdown_fix = array('heating_make', 'heating_model', 'heating_model_no', 'water_heater_make', 'water_heater_model', 'water_heater_model_no', 'central_air_make', 'central_air_model', 'central_air_model_no');
			foreach($dropdown_fix as $ddfx) { 
				if(isset($_REQUEST[$ddfx . '_usedd']) && $_REQUEST[$ddfx . '_usedd'] == 1) { 
					$_REQUEST[$ddfx] = @$_REQUEST[$ddfx . '2'];
				}
			}
		}

		$sql_array = array();
		foreach($step_fields[$_REQUEST['submitting_step']] as $fld) {			
			if(!isset($_REQUEST[$fld])) {
				$sql_array[$fld] = '0';
			} else {
				if(in_array($fld, $number_fields) && isset($_REQUEST[$fld]) && $_REQUEST[$fld] != '') { 
					preg_match_all('/[\d\.]/', $_REQUEST[$fld], $match);
					$match = implode('', $match[0]);
					$sql_array[$fld] = $match;
				} else {
					$sql_array[$fld] = $_REQUEST[$fld];
				}
			}
		}
		$sql->fromarray('update', 'energy_profile', $sql_array, ' WHERE user_id = ' . smartq($_SESSION['user_id']));
	} elseif(isset($_REQUEST['submitting_step']) && $_REQUEST['submitting_step'] == 6) { 
		$sql->query("DELETE FROM energy_profile_lighting WHERE user_id = " . smartq($_SESSION['user_id']));
		for($x = $form_prefill['num_rooms']; $x >= 1 ; $x--) { 
			if(empty($_REQUEST['energystar_' . $x])) {
				$_REQUEST['energystar_' . $x] = '0';
			}
			$sql->fromarray('insert', 'energy_profile_lighting', array(
				'user_id' => $_SESSION['user_id'],
				'room' => $_REQUEST['room_' . $x],
				'num_bulbs' => $_REQUEST['num_bulbs_' . $x],
				'watts' => $_REQUEST['watts_' . $x],
				'energy_star' => $_REQUEST['energystar_' . $x]
			));
		}
	}
		
	// now just blindly select all the data we need for the energy profile
	$q = $sql->query("SELECT * FROM energy_profile WHERE user_id = " . smartq($_SESSION['user_id']));
	$form_prefill = mysql_fetch_assoc($q);

	if($step == 6) { 
		$q = $sql->query("SELECT * FROM energy_profile_lighting WHERE user_id = " . smartq($_SESSION['user_id']) . " ORDER BY lighting_id DESC");
		$x = 0;
		while($r = mysql_fetch_assoc($q)) { 
			$x++;
			$form_prefill['room_' . $x] = $r['room'];
			$form_prefill['num_bulbs_' . $x] = $r['num_bulbs'];
			$form_prefill['watts_' . $x] = $r['watts'];
			$form_prefill['energystar_' . $x] = $r['energy_star'];
		}
	}

	$file = '../include/energy_profile_forms/step' . $step . '.inc.php';

	if(is_readable($file)) {
		require $file;
	}

/*
	<table style="clear:both">
	<tr>
		<?php if($step != 1) { ?>
		<td><a href="javascript: profileStep(<?php echo $step - 1; ?>);">&lt;&lt; Back</a></td>
		<?php } else { echo '<td>&nbsp;</td>'; } 
		if($step != 7) {	
		?>
		<td><a href="javascript: profileStep(<?php echo $step + 1; ?>);">Next &gt;&gt;</a></td>
		<?php } else { echo '<td>&nbsp;</td>'; } ?>
	</tr>
	</table> */
?>