<?php
ini_set('display_errors', 1);
error_reporting(E_ALL & ~E_NOTICE);
//initiate PHP 5 soap client with the public wsdl on the HES-Sandbox system
$client = new SoapClient('http://sandbox-hesapi.hescloud.net/session/wsdl', array('exceptions' => 0,'trace' => 1));
//This is your 3scale client guid, you must get this from HES.
$params['client_guid'] = '2363a0e42cc62f642a9a81f0a3b9ee4c';
//use a valid zip code to create a new session
$params['zipcode'] = '90039';
//This signifies the website type, just leave as 0
$params['website_type'] = '0';

//Now lets create a new session, and grab the valid session id.
$result = $client->newSession($params['client_guid'], $params['zipcode'], $params['website_type']);
if (is_soap_fault($result)) {
	trigger_error("SOAP Fault: (faultcode: {$result->faultcode}, faultstring: {$result->faultstring})", E_USER_ERROR);
}
//a lot of data is returned, this is designed to build the forms on a GUI website, but we only need the session id.
$last_result_array = end($result);//$result[61];
$last_result_array = $last_result_array->_classProperties;
$params['session_id'] = $last_result_array['defaultValue'];

//Now you must build object arrays that meet the wsdl specifications. See 3scale documentation for the various options for these values.
$extraInputs = array (
    'controller' => 'consumer',
    'action' => 'save-and-go',
    'module' => 'default',
    'nextPage' => '/consumer/quick-building-design',
    'nextTask' => 'next',
    'purpose_other' => '',
    'state' => 'alabama',
    'utility' => '7',
    'tariff' => 'ag-4',
    'finished_detailed' => '0',
    'dlpRearProjectionTVTimeUnit' => '',
    'formGroup' => 'Detailed',
    'formForm' => 'General'
  );
$inputArray['extraInputs'] = $extraInputs;

$saveInputs[] = array (
      'inputTableName' => 'whole_house_input',
      'inputColumnName' => 'uniqueName',
      's_value' => 'hespro dev sessionid='.$params['session_id']
    );
$saveInputs[] = array (
      'inputTableName' => 'whole_house_input',
      'inputColumnName' => 'emailAddress',
      's_value' => 'frank@frank.com'
	  );
$saveInputs[] = array (
      'inputTableName' => 'whole_house_input',
      'inputColumnName' => 'address',
      's_value' => '2283 Spark Ave'
      );

$inputArray['saveInputs'] = $saveInputs;

$inputArray['lightInputs'] = array();

//now we call the saveSession11 method, and get the restult
$result = $client->saveSession11($params['client_guid'], $params['session_id'], $inputArray, 1);
$keyText = "Result: \n";
$keyText .= print_r($result, true);
echo $keyText ."\n\n";

//now we call the retrieveSummarySessionResults11 method to grab a section of the calculated results, there are many sections (and their associated methods), see 3scale documentation
$result = $client->retrieveSummarySessionResults11($params['client_guid'], $params['session_id']);
$keyText = "Result: \n";
$keyText .= print_r($result, true);
echo $keyText ."\n\n";
if (is_soap_fault($result)) {
	trigger_error("SOAP Fault: (faultcode: {$result->faultcode}, faultstring: {$result->faultstring})", E_USER_ERROR);
}
 ?>
