<?php
$categories = json_decode('
	[	"Refrigerator",
		"Freezer",
		"Dryer",
		"Washer",
		"Microwave",
		"Coffee Maker",
		"Gas Stove",
		"Electric Stove",
		"Oven",
		"Dishwasher",
		"Room AC",
		"Geothermal Heat Pump",
		"Gas Furnace",
		"Oil Furnace",
		"Central Air Unit",
		"Gas Storage Water Heater",
		"Solar Water Heater",
		"Tankless Gas Water Heater",
		"Solar Panel"
	]');
sort($categories);

// If there isn't yet a record of searches, create an empty one
if (!isset($_SESSION['searches']))$_SESSION['searches'] = array();

// Modify the appliance type, if "empty" so php sees a null value
if ($_GET['appliance_type'] == 'empty') $_GET['appliance_type'] = 0;

function record_search_history(){
	// If user entered a new search												
	if (   (isset($_GET['keywords']) || isset($_GET['appliance_type']))
		 &&($_GET['source'] != 'link')){

		// Add this search string to the history
		$_SESSION['searches'][] = array(
				'search_string' => $_GET['keywords'], 
				'appliance_type'=> $_GET['appliance_type'],
				'query_string'  => ($_SERVER['QUERY_STRING'].'&source=link'),
				);		
	}
}

function show_search_form()
{
?>	<h1>Search Products</h1>
	<form method="get" action="">
		<input type="hidden" name="page" value="1" />
		<input type="hidden" name="page_size" value="5" />
		<table>
			<tr>
				<td colspan="3">
					<strong>Keywords</strong><br />
					<input type="text" name="keywords" value="<?php echo $_GET['keywords'] ?>" style="width:260px;" />
				</td>
			</tr>
			<tr>
				<td style="width:20px;">
					<strong>Price Min</strong><br />
					<input type="text" name="min_price" value="<?php echo $_GET['min_price'] ?>"  size=6 />
				</td>
				<td style="padding-left:10px;">
					<strong>Price Max</strong><br />
					<input type="text" name="max_price" value="<?php echo $_GET['max_price'] ?>" size=6 />
				</td>
				<td>
					<strong>&nbsp;</strong><br />
					<input type="submit" name="Search" value="Search" /> 
				</td>
					
			</tr>
			<tr>
				<td colspan=2>
					<strong>Appliance Type</strong><br />
					<select name="appliance_type" style="width:180px;">
					<option selected="selected" value="empty">
						--   all types   --
					</option>
					<?php 
					foreach ($categories as $key=>$c) 
					{ 
					?>
						<option <?php if($_GET['appliance_type'] == $c){ ?>selected="selected" <?php } ?>><?php echo $c ?></option>
					<?php 
					} 
					?>
					</select>
				</td>
		
			</tr>
		</table>
		<!--
		<p><b>Previous Searches</b></p>
		<ul style="list-style:none;">
<?php		
		$count = 0;
		foreach (array_reverse($_SESSION['searches']) as $search)
		{	
			$count++;
			$num_past_searches_to_display = 8;
			if($count > $num_past_searches_to_display)
			{
				break;
			}
			$search_string = $search['search_string'];
			$appliance_type = $search['appliance_type'];
?>			<li>
				<a href="search.php?keywords=<?php echo urlencode($search_string) ?>&appliance_type=<?php echo urlencode($appliance_type) ?>&page=1&page_size=5&source=link">
					<?php echo ($search_string != '') ? $search_string : '<em>(empty)</em>'; ?>
					<?php echo ($appliance_type != 'empty') ? '[ ' . $appliance_type . ' ]' : ''; ?>
				</a>
			</li>
<?php		
		}
?>		</ul>
		-->		
	</form>
<?php		
}
function show_page_link ($page_num, $text){
?> 	<a href="?page=<?php echo $page_num ?>&source=link&page_size=<?php echo $_GET['page_size'] ?>&keywords=<?php echo urlencode($_GET['keywords']) ?>&appliance_type=<?php echo urlencode($_GET['appliance_type']) ?>" style="text-decoration:none;color:blue;">
		<?php echo $text ?>
	</a>
<?php
}

function show_pagination_nav($cur_page, $last_page){
?>
		<div class="pagination_nav" style="float:right;">
<?php			echo "<small>page No: $cur_page. page size: {$_GET['page_size']}</small><br />";
?>			<span class="pnprev">
<?php				if ($cur_page != 1) show_page_link($cur_page - 1, htmlspecialchars('<< Previous'));
				else echo '<< Previous';
?>			</span>
				&nbsp;&nbsp;|&nbsp;&nbsp;
			<span class="pagination_nav_prev">
<?php				if($cur_page >= 3){
					echo ($cur_page == 1)? ', ' : ' &nbsp;';
					echo implode(', ', array($cur_page - 1));	
					echo ', ';
				}
				else if ($cur_page == 2){
					echo '1, ';
				}
?>			</span>
			<span class="pagination_nav_cur">
<?php				echo  '<strong>' . $cur_page . '</strong> ';
				if ($cur_page != $last_page) echo ', ';
?>			</span>
			<span class="pagination_nav_following"	>
<?php 				if (! ($cur_page >= $last_page) ) {
					echo implode ( ', ', 	
							range(	$cur_page + 1, 
								( ($cur_page + 1) > $last_page ) ? 
									 $last_page 		: 
									($cur_page + 1)
								)
							 );
				}		
?>			</span>
				&nbsp;&nbsp;|&nbsp;&nbsp;
			<span class="pnnext">
<?php 				if ($cur_page != $last_page) show_page_link($cur_page + 1, htmlspecialchars('Next >>'));
				else echo 'Next >>';
?>			</span>	 <br />
			<span class="first">
<?php				if($cur_page >= 2){
					show_page_link(1, htmlspecialchars(' First '));
				}
				else echo ' First ';
?>			</span>
			<span class="last">
<?php				if(! ($cur_page >= $last_page)) {echo '... '; show_page_link($last_page, ' Last (' . $last_page . ')' ); }
				else if(! ($cur_page >= $last_page - 1)){
					show_page_link($last_page, ' Last');
			
				}
				else
					echo '... Last (' . $last_page . ')';
?>			</span>
		</div>
		<!--<div style="clear:both;"></div>-->
<?
}

function smart_like($s=''){
	return ' LIKE "%' . mysql_real_escape_string($s) . '%" '; 
}

function show_search_results($search_string='', $page=0, $page_size=0, $appliance_type=0, $min_price="", $max_price=""){
	global $sql,$_CART;

	// Verify parameters
	if($page == 0 or $page_size == 0){
		echo '<p>The page number cannot be zero. The page size cannot be zero.</p>';
		return;
	}		
			
	// Remove useless whitespace from the search string
	$search_string = trim($search_string);
		
	// Isolate the keywords
	$array_of_strings = explode(' ', $search_string);
			
	// Begin the query:
	$sql_query =  "SELECT app_id,make, model, model_number, appliance_type ";
	$sql_query .= "FROM appliance WHERE  ";
			
	// Find each term in at least one of the searched fields
	foreach($array_of_strings as $item){
		$sql_like_array = array(); // Must be cleared before each loop run
		$sql_like_array[] = "( make  		COLLATE latin1_swedish_ci " . smart_like( $item ) . " )";
		$sql_like_array[] = "( model 		COLLATE latin1_swedish_ci " . smart_like( $item ) . " )";
		$sql_like_array[] = "( model_number 	COLLATE latin1_swedish_ci " . smart_like( $item ) . " )";
		$sql_like_array[] = "( appliance_type 	COLLATE latin1_swedish_ci " . smart_like( $item ) . " )";
		
		// Join the LIKE expressions with an OR condition
		$sql_keyword_queries[] = implode(" OR ", $sql_like_array);
		}
			
		// Each search term must have at least one match
		$sql_query .= '(';
		$sql_query .= implode (')AND(', $sql_keyword_queries);
		$sql_query .= ')';
		
		
		// Handle min and max prices
		if(isset($min_price) && $min_price !='') $sql_query .= "AND ( price >= ".smartq($min_price)." )";
		if(isset($max_price) && $max_price !='') $sql_query .= "AND ( price <= ".smartq($max_price)." )";
			
		// Specify an appliance type, if the user specified.
		if($appliance_type)
			$sql_query .= " AND appliance_type = " . smartq($appliance_type);
		

		// Get the number of matches
		$r = $sql->query('SELECT COUNT(*) FROM ( ' . $sql_query . ' ) AS o');
		if($r){ 
			$row = mysql_fetch_assoc($r);
			$match_count = $row['COUNT(*)'];
		}
			
		// Calculate the MySQL result index of the first element on the 
		// current page based on the page number and size.
		$first 	= ($page-1) * $page_size;	
		$last 	= ceil ( $match_count / $page_size );
		
		// Let MySQL do our pagination
		$sql_query .= " LIMIT $first, $page_size";
		
		// Get the desired page of search results
		$r = $sql->query($sql_query);
		
		// If no results, apologize
		if(! mysql_num_rows($r)) {
			echo '<br /><br /><h1>Sorry, no results.</h1>';
			echo '<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />';
			return;
		}
			
		// Display the results
		show_pagination_nav($page,$last);
			
		if ($_GET['keywords'] == '') $search_string=htmlspecialchars('(empty)');
		else $search_string = htmlspecialchars($_GET['keywords']);
			
		echo "<p style=\"line-height: 2em;\">$match_count results for keywords: <strong><big>$search_string</big></strong></p>";
		
		if ($appliance_type != 0) echo 'Appliance Type: ' . $appliance_type;
		
		echo '</h1>';	
?>		
<script type="text/javascript" src="includes/client_side/scripts/jquery-1.3.2.min.js">
</script>
<script type="text/javascript" src="includes/client_side/scripts/cart.js">
</script>
<div style="width:100%;text-align:center;padding:10px;font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#666666;">
<img src="includes/client_side/images/cart.gif" id="cart_icon" /><img src="includes/client_side/images/loading.gif" id="loading_icon" style="display:none;" />&nbsp;You have <span id="cart_products_count" style="font-weight:bold;"><?php echo $_CART->CountProductsInCart();?></span> products in your <a href="cart">shopping cart</a>
</div>
<table 	class="search_results" 
			style="width:100%; text-align:left; float:left; padding: 10px; padding-left: 0;" cellpadding="0" cellspacing="0" >
<?			$count=$first;
			while ($row = mysql_fetch_assoc($r)){
				++$count;
				show_product($row, $count);
			}			
?>		</table>
<?	
			//show_pagination_nav($page,$last);		
}

function show_product($row=array(), $count){
	extract($row);  
?>		
<!-- OLD CODE STARTS HERE 
<tr>
	  	<th>Type</th><th>Make</th><th rowspan=2>Price</th>
		</tr>
		<tr>
			<td> $appliance_type ?></td>
			<td> $make ?></td>		
		</tr>
		<tr>
			<th>Model</th>
			<th>Model Number</th>
			<td rowspan=2> $price ?></td>
		</tr>
		<tr>
			<td> $model ?></td>
			<td> $model_number ?></td>						
			
		</tr>
		<tr>
			<td>&nbsp;</td>
		</tr>
OLD CODE ENDS HERE -->        
<!-- NEW CODE STARTS HERE -->        
        <tr style="border:solid 1px #999999;width:100%;">
    <td width="126" style="border-top:solid 1px #999999;border-left:solid 1px #999999;border-bottom:solid 1px #999999;" align="center" valign="middle"><img src="includes/client_side/images/noImage.gif" /></td>
    <td width="294" style="border-top:solid 1px #999999;border-bottom:solid 1px #999999;">
    <table width="271" border="0">
      <tr>
        <td width="90" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#333333;font-weight:bold;text-align:right;padding-right:3px;">Type:</td>
        <td width="171" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#333333;font-weight:normal;text-align:left;"><?php echo $appliance_type;?></td>
      </tr>
      <tr>
        <td width="90" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#333333;font-weight:bold;text-align:right;padding-right:3px;">Model:</td>
        <td width="171" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#333333;font-weight:normal;text-align:left;"><?php echo $model;?></td>
      </tr>
      <tr>
        <td width="90" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#333333;font-weight:bold;text-align:right;padding-right:3px;">Make:</td>
        <td width="171" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#333333;font-weight:normal;text-align:left;"><?php echo $make;?></td>
      </tr>
      <tr>
        <td width="90" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#333333;font-weight:bold;text-align:right;padding-right:3px;">Model Number:</td>
        <td width="171" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#333333;font-weight:normal;text-align:left;"><?php $model_number;?></td>
      </tr>
    </table>
    </td>
    <td width="102" style="border-top:solid 1px #999999;border-bottom:solid 1px #999999;">
    <span style="text-align:center;font-family:Arial, Helvetica, sans-serif;font-size:24px;font-weight:bold;color:#006699;">
    <?php echo FormatPrice($price);?>    </span>
    <br />
    <span style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#666666;">
    QTY:&nbsp;<input type="text" size="2" name="product_<?php echo $app_id;?>_quantity" id="product_<?php echo $app_id;?>_quantity" style="font-family:Arial, Helvetica, sans-serif;font-size:12px;color:#666666;text-align:center;" value="1" />
    </span>
    </td>
    <td width="111" align="center" valign="middle" style="border-top:solid 1px #999999;border-bottom:solid 1px #999999;border-right:solid 1px #999999;padding-right:10px;text-align:center;"><img src="includes/client_side/images/add-to-cart.gif" width="100" height="41" style="cursor:pointer;" title="Add this product to my cart" onclick="AddProductToCart(<?php echo $app_id;?>)" /></td>
  </tr>
  <tr>
  <td colspan="4" height="5">
  </td>
  </tr>
<?php
}
?>
