<?php
/*************************************************************************/
/*	This software has been developed and is property of CodeHid Team     */
/*	All rights are reserved, you are not authorized to use, modify or    */
/*	distribute this software without CodeHid Team's authorization.		 */	
/*																		 */																	
/*	Developer: Nelio Contrera											 */
/*	Coyright CodeHid Team 2008. www.codehid.com                          */
/*************************************************************************/
class Database
{
	private $_location;
	private $_username;
	private $_password;
	private $_db_name;
	private $_current_connection;
	private $_error_no;
	private $_mysql_error;
	private $_current_result;
	private $_connected_mode;

	public function __construct($location,$username,$password,$name,$connected_mode=false)
	{
		$test=@mysql_connect($location,$username,$password);
		if(mysql_errno()!=0)
		{
			$this->_error_no=mysql_errno();
			$this->_mysql_error=mysql_error();
			return;			
		}
		@mysql_select_db($name,$test);
		if(@mysql_errno($test)!=0)
		{
			$this->_error_no=@mysql_errno($test);
			$this->_mysql_error=@mysql_error($test);
			return;			
		}
		@mysql_close($test);
		$this->_location=$location;
		$this->_username=$username;
		$this->_password=$password;
		$this->_db_name=$name;
		$this->_current_connection=false;
		$this->_error_no=0;
		$this->_mysql_error="";
		$this->_connected_mode=$connected_mode;
	}
	public function __destructor()
	{
		$this->Disconnect();
	}
	public function Disconnect()
	{
		if($this->_current_connection)
			@mysql_close($this->_current_connection);
		$this->_current_connection=false;
	}
	public function __get($property)
	{
		switch(strtolower($property))
		{
			case "error":
				return $this->_error_no;
				break;
			case "mysqlerror":
				return $this->_mysql_error;
				break;
			case "numrows":
				return $this->NumRows();
				break;
			case "affected":
				return $this->Affected();
				break;
			case "lastid":
				return $this->LastId();
				break;
			case "assoc":
				return $this->AssocNext();
				break;
			case "next":
				return $this->Next();
				break;
		}
	}
	
	public function Connect()
	{
		if($this->_current_connection)
			@mysql_close($this->_current_connection);
		$this->_current_connection=@mysql_connect($this->_location,$this->_username,$this->_password);
		@mysql_select_db($this->_db_name,$this->_current_connection);
		$this->_error_no=mysql_errno();
		$this->_mysql_error=mysql_error();
		return $this->_error_no==0;		
	}
	
	public function Query($query)
	{
		if(!$this->_current_connection)
			$this->Connect();
		if($this->_current_connection)
		{
			$this->_current_result=@mysql_query($query,$this->_current_connection);
			$this->_error_no=@mysql_errno($this->_current_connection);
			$this->_mysql_error=@mysql_error($this->_current_connection);
		}
		return $this->_error_no==0;
	}
	
	public function PerformQuery($query,$get_id=false)
	{
		if(!$this->_current_connection)
			$this->Connect();
		$this->_current_result=@mysql_query($query,$this->_current_connection);
		$this->_error_no=@mysql_errno($this->_current_connection);
		$this->_mysql_error=@mysql_error($this->_current_connection);
		if($get_id)
			$result=$this->LastId;
		if(!$this->_connected_mode)
			$this->Disconnect();
		if(!$get_id)
			return $this->_error_no==0&&@mysql_errno($this->_current_connection)==0;
		else
			return $result;
	}
	
	public function GetQueryResult($query,$row_instance_enabled=true)
	{
		if(!$this->_current_connection)
			$this->Connect();
		$this->_current_result=@mysql_query($query,$this->_current_connection);
		$this->_error_no=@mysql_errno($this->_current_connection);
		$this->_mysql_error=@mysql_error($this->_current_connection);
		$result=false;
		if($this->NumRows!=0)
			$result=($row_instance_enabled)?new Row_Instance($this->Assoc):$this->Assoc;
		if(!$this->_connected_mode)
			$this->Disconnect();
		return $result;
	}
	
	public function FreeResult()
	{
		if($this->_current_result&&$this->_current_connection)
			@mysql_free_result($this->_current_result);
		$this->_current_result=false;
	}
	
	private function AssocNext()
	{
		if($this->_current_result&&$this->_current_connection)
			return @mysql_fetch_assoc($this->_current_result);
		return array();
	}
	
	private function Next()
	{
		if($this->_current_result&&$this->_current_connection)
			return @mysql_fetch_array($this->_current_result);
		return array();
	}
	
	private function LastId()
	{
		if($this->_current_connection)
			return @mysql_insert_id($this->_current_connection);
		return -1;
	}
	private function NumRows()
	{
		if($this->_current_result&&$this->_current_connection)
			return @mysql_num_rows($this->_current_result);
		return 0;
	}
	private function Affected()
	{
		if($this->_current_connection)
			return @mysql_affected_rows($this->_current_connection);
		return 0;
	}
	
	public function QueryToArray($query,$row_instance_enabled=true)
	{
		if(!$this->_current_connection)
			$this->Connect();
		$this->Query($query);
		if($this->Error!=0)
		{
			if(!$this->_connected_mode)
				$this->Disconnect();
			return false;
		}
		$result=array();
		while($tmp=$this->Assoc)
		{
			$result[]=($row_instance_enabled)?new Row_Instance($tmp):$tmp;
		}
		if(!$this->_connected_mode)
			$this->Disconnect();
		return $result;
	}
	
	public function ResultToArray($row_instance_enabled=true)
	{
		$result=array();
		while($tmp=$this->Assoc)
		{
			$result[]=($row_instance_enabled===true)?new Row_Instance($tmp):$tmp;
		}
		return $result;
	}
	
	public function ArrayToQuery($array,$update=true)
	{
		$result="";
		foreach($array as $key=>$value)
		{
			$result.=(strlen($result)==0)?"":",";
			$result.=($update)?mysql_escape_string($key)."='".mysql_escape_string($value)."'":"'".mysql_escape_string($value)."'";
		}		
		return $result;
	}
	
	public function InsertObject($table,$rowInstanceObject,$extraFields=array(),$capital=true)
	{
		$insertFields="";
		$insertValues="";
		$objectKeys=$rowInstanceObject->GetKeys();
		foreach($objectKeys as $key=>$value)
		{
			$fieldName=($capital)?strtoupper($value):$value;
			$insertFields.=($insertFields=="")?$fieldName:",$fieldName";
			$insertValues.=($insertValues=="")?"'".mysql_escape_string($rowInstanceObject->__get($value))."'":",'".mysql_escape_string($rowInstanceObject->__get($value))."'";
		}
		
		foreach($extraFields as $key=>$value)
		{
			$fieldName=($capital)?strtoupper($key):$key;
			$insertFields.=($insertFields=="")?$fieldName:",$fieldName";
			$insertValues.=($insertValues=="")?"'".mysql_escape_string($value)."'":",'".mysql_escape_string($value)."'";
		}
		
		return $this->PerformQuery("INSERT INTO ".$table."($insertFields) VALUES($insertValues)",true);
	}
	
	public function UpdateObject($table,$rowInstanceObject,$conditions,$capital=true)
	{
		if(count($conditions)==0)
			return false;
		
		$updateFields="";
		$objectKeys=$rowInstanceObject->GetKeys();
		foreach($objectKeys as $key=>$value)
		{
			$fieldName=($capital)?strtoupper($value):$value;
			$fieldValue="'".mysql_escape_string($rowInstanceObject->__get($value))."'";
			$updateFields.=($updateFields=="")?"$fieldName=$fieldValue":",$fieldName=$fieldValue";
		}
		
		$conditionsQuery="";
		foreach($conditions as $key=>$value)
		{
			$fieldName=($capital)?strtoupper($key):$key;
			$fieldValue="'".mysql_escape_string($value)."'";
			$conditionsQuery.=($conditionsQuery=="")?"$fieldName=$fieldValue":" AND $fieldName=$fieldValue";
		}
		
		return $this->PerformQuery("UPDATE ".$table." SET $updateFields WHERE $conditionsQuery");
	}
	
	
}
?>