<?php
class ProjectsManagement
{
	public function GetMyProjects()
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return array();
		$projects=$_DB_LAYER->QueryToArray("SELECT PROJECT_ID,PROJECT_NAME,INSTALL_DATE,PROJECT_STATUS FROM PROJECTS WHERE USER_ID=".$_SESSION['user_id']." ORDER BY PROJECT_ID DESC");
		if(!$projects)
			return array();
		foreach($projects as $key=>$project)
		{
			$bidsData=$_DB_LAYER->GetQueryResult("SELECT COUNT(BID_ID) AS BIDS FROM PROJECT_BIDS WHERE PROJECT_ID=".mysql_escape_string($project->Project_Id));
			$projects[$key]->Bids=(is_numeric($bidsData->Bids)&&$bidsData->Bids>0)?$bidsData->Bids:0;
		}
		return $projects;
	}
	
	public function UpdateProjectStatus($projectId,$newStatus)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->PerformQuery("UPDATE PROJECTS SET PROJECT_STATUS='".mysql_escape_string($newStatus)."' WHERE PROJECT_ID=".mysql_escape_string($projectId)." AND USER_ID=".$_SESSION['user_id']);
	}
	
	public function DeleteProject($projectId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->PerformQuery("DELETE FROM PROJECTS WHERE PROJECT_ID=".mysql_escape_string($projectId)." AND USER_ID=".$_SESSION['user_id']);
	}
	public function GetProductsFromMyOrders()
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return array();
		
		return $_DB_LAYER->QueryToArray("SELECT DISTINCT op.V_APP_ID AS PRODUCT_ID,vap.title AS NAME FROM ORDER_PRODUCTS op,vendor_appliance vap WHERE op.ORDER_ID IN (SELECT ORDER_ID FROM ORDERS WHERE USER_ID=".$_SESSION['user_id'].") AND op.V_APP_ID=vap.V_APP_ID");
	}
	public function GetProjectDetails($projectId,$includeBids=false)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$project=$_DB_LAYER->GetQueryResult("SELECT * FROM PROJECTS WHERE PROJECT_ID=".mysql_escape_string($projectId)." AND USER_ID=".$_SESSION['user_id']);
		if(!$project)
			return false;
		$projectProducts=$_DB_LAYER->QueryToArray("SELECT * FROM vendor_appliance WHERE v_app_id IN (SELECT V_APP_ID FROM PROJECTS_PRODUCTS WHERE PROJECT_ID=".mysql_escape_string($projectId).")");
		$products=array();
		if(count($projectProducts)>0)
		{
			foreach($projectProducts as $key=>$product)
			{
				$products[]=$product->V_APP_ID;
			}
		}
		$project->Products=$products;
		$project->ProductsList=$projectProducts;
		if($includeBids)
			$project->Bids=$_DB_LAYER->QueryToArray("SELECT pb.*,u.fname AS VENDOR_NAME,u.lname AS VENDOR_LASTNAME FROM PROJECT_BIDS pb,user u WHERE pb.PROJECT_ID=".mysql_escape_string($projectId)." AND pb.USER_ID=u.USER_ID");
		return $project;
	}
	public function UpdateBidStatus($bidId,$status)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$_DB_LAYER->PerformQuery("UPDATE PROJECT_BIDS SET BID_STATUS='".mysql_escape_string($status)."' WHERE BID_ID=".mysql_escape_string($bidId));
		if($_DB_LAYER->Error!=0)
			return false;
		if($status=='acepted')
		{
			$_DB_LAYER->PerformQuery("UPDATE PROJECTS SET PROJECT_STATUS='in-process' WHERE PROJECT_ID IN (SELECT PROJECT_ID FROM PROJECT_BIDS WHERE BID_ID=".mysql_escape_string($bidId).")");
			$_DB_LAYER->PerformQuery("UPDATE PROJECT_BIDS SET BID_STATUS='rejected' WHERE BID_ID<>".mysql_escape_string($bidId));
		}
	}
	public function SendMessage($bidId,$message)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->PerformQuery("INSERT INTO BID_COMMENTS(BID_ID,USER_ID,COMMENT_DATE,COMMENT) VALUES(".mysql_escape_string($bidId).",".$_SESSION['user_id'].",".time().",'".mysql_escape_string($message)."')");
	}
	public function UpdateProject($_PROJECT_INFO)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$date=explode("/",$_PROJECT_INFO->Install_Date);
		$_PROJECT_INFO->Install_Date=mktime(0,0,0,$date[0],$date[1],$date[2]);
		$projectId=$_PROJECT_INFO->Project_Id.$_PROJECT_INFO->ProjectId;
		$_PROJECT_INFO->RemoveKey('action');
		$_PROJECT_INFO->RemoveKey('mode');
		$_PROJECT_INFO->RemoveKey('project_id');
		$products=$_PROJECT_INFO->Products;
		$_PROJECT_INFO->RemoveKey('products');
		$_DB_LAYER->PerformQuery("START TRANSACTION");
	    $_DB_LAYER->UpdateObject("PROJECTS",$_PROJECT_INFO,array("PROJECT_ID"=>$projectId,"USER_ID"=>$_SESSION['user_id']));
		if($_DB_LAYER->Error!=0)
		{
			$_DB_LAYER->PerformQuery("ROLLBACK");
			return false;
		}
		
		$_DB_LAYER->PerformQuery("DELETE FROM PROJECTS_PRODUCTS WHERE PROJECT_ID=".mysql_escape_string($projectId));
		if($_DB_LAYER->Error!=0)
		{
			
			$_DB_LAYER->PerformQuery("ROLLBACK");
			return false;
		}
		if(is_array($products))
		{
			foreach($products as $key=>$product)
			{
				$_DB_LAYER->PerformQuery("INSERT INTO PROJECTS_PRODUCTS VALUES(".mysql_escape_string($projectId).",".mysql_escape_string($product).")");
				if($_DB_LAYER->Error!=0)
				{
					
					$_DB_LAYER->PerformQuery("ROLLBACK");
					return false;
				}
			}
		}
		$_DB_LAYER->PerformQuery("COMMIT");
		return true;
	}
	public function GetBidDetails($bidId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$bid=$_DB_LAYER->GetQueryResult("SELECT pb.*,p.PROJECT_NAME,u.fname AS VENDOR_NAME,u.lname AS VENDOR_LASTNAME,u.email FROM PROJECT_BIDS pb,PROJECTS p,user u WHERE pb.BID_ID=".mysql_escape_string($bidId)." AND pb.PROJECT_ID=p.PROJECT_ID AND p.USER_ID=".$_SESSION['user_id']." AND u.user_id=pb.USER_ID");
		if(!$bid)
			return false;
		$bid->Comments=$_DB_LAYER->QueryToArray("SELECT * FROM BID_COMMENTS WHERE BID_ID=".$bid->Bid_Id);
		return $bid;
	}
	public function CreateProject($_PROJECT_INFO)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$date=explode("/",$_PROJECT_INFO->Install_Date);
		$_PROJECT_INFO->Install_Date=mktime(0,0,0,$date[0],$date[1],$date[2]);
		$_PROJECT_INFO->RemoveKey('action');
		$_PROJECT_INFO->RemoveKey('mode');
		$_PROJECT_INFO->RemoveKey('project_id');
		$_PROJECT_INFO->RemoveKey('termsagreement');
		$_PROJECT_INFO->User_Id=$_SESSION['user_id'];
		$_PROJECT_INFO->Creation_Date=time();
		$_PROJECT_INFO->Project_Status='open';
		$products=$_PROJECT_INFO->Products;
		$_PROJECT_INFO->RemoveKey('products');
		$_DB_LAYER->PerformQuery("START TRANSACTION");
		$projectId=$_DB_LAYER->InsertObject("PROJECTS",$_PROJECT_INFO);
		if($_DB_LAYER->Error!=0)
		{
			$_DB_LAYER->PerformQuery("ROLLBACK");
			return false;
		}
		if(is_array($products))
		{
			foreach($products as $key=>$product)
			{
				$_DB_LAYER->PerformQuery("INSERT INTO PROJECTS_PRODUCTS VALUES($projectId,".mysql_escape_string($product).")");
				if($_DB_LAYER->Error!=0)
				{
					$_DB_LAYER->PerformQuery("ROLLBACK");
					return false;
				}
			}
		}
		$_DB_LAYER->PerformQuery("COMMIT");
		return true;
	}
	public function RateVendor($bidId,$rating,$comments)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$rating=(is_numeric($rating)&&$rating>0&&$rating<=5)?$rating:1;
		$_DB_LAYER->PerformQuery("UPDATE PROJECT_BIDS SET RATING=$rating,RATING_COMMENT='".mysql_escape_string($comments)."' WHERE BID_ID=".mysql_escape_string($bidId)." AND PROJECT_ID IN (SELECT PROJECT_ID FROM PROJECTS WHERE USER_ID=".$_SESSION['user_id'].")");
	}
}
?>