<?php
error_reporting(1);
ini_set('error_reporting', E_ALL);
?> 
<?php



function GetRate()
{
	$query = '<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
   <soap:Body>
      <GetQuote xmlns="http://www.echo.com/">
         <echoRateRequest>
            <AuthInfo>
               <UserId>%1s</UserId>
               <Password>%2s</Password>
            </AuthInfo>
            <Requests>
               <Request>
                  <TotalWeight>%3$s</TotalWeight>
                  <Items>
                     <Item>
                        <Class>%4$s</Class>
                        <Weight>%3$s</Weight>
                     </Item>
                  </Items>
                  <Accessorials>
                     <Accessorial>
                        <AccessorialId>12</AccessorialId>
                     </Accessorial>
                     <Accessorial>
                        <AccessorialId>18</AccessorialId>
                     </Accessorial>
                  </Accessorials>
                  <Origin>
                     <Name/>
                     <Address1/>
                     <Address2/>
                     <City/>
                     <State/>
                     <Zip>%5$s</Zip>
                  </Origin>
                  <Destination>
                     <Name/>
                     <Address1/>
                     <Address2/>
                     <City/>
                     <State/>
                     <Zip>%6$s</Zip>
                  </Destination>
                  <PickupDate>2009-04-26</PickupDate>
                  <ShipmentType>Third Party</ShipmentType>
                  <PalletQty>0</PalletQty>
                  <ReturnMultipleCarriers>false</ReturnMultipleCarriers>
                  <SaveQuote>false</SaveQuote>
               </Request>
            </Requests>
         </echoRateRequest>
      </GetQuote>
   </soap:Body>
</soap:Envelope>';

	if ($_POST)
	{	/*
		$userid = "ER87207";
		$password = "Echo7207";
		$weight = $_POST['weight'];
		$class = $_POST['class'];
		$origin = $_POST['origin'];
		$destination = $_POST['destination'];
		*/
		global $userid;
		global $password;
		$weight = 123;
		$class = 50;
		$origin = 91101;
		$destination = 60425;
	}
	else
	{
		return;
	}

	echo $formattedQuery = sprintf($query, $userid, $password, $weight, $class, $origin, $destination);

	$ch = curl_init ();
	curl_setopt ($ch, CURLOPT_URL, "http://services.echo.com/Quote.asmx");
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_TIMEOUT, 20);
	curl_setopt ($ch, CURLOPT_HEADER, 1);
	curl_setopt ($ch, CURLOPT_POST, 1);
	curl_setopt ($ch, CURLOPT_POSTFIELDS,$formattedQuery);
	$header = array();
	$header[] = "Content-Type: text/xml";
	$header[] = 'SOAPAction: "http://www.echo.com/GetQuote"';
	$header[] = "User-Agent: windows";
	$header[] = "Host: services.echo.com";
	$header[] = "Content-Length: ".strlen($formattedQuery);
	$header[] = "Connection: close";
	curl_setopt ($ch, CURLOPT_HTTPHEADER, $header);
	
	$result = curl_exec ($ch);
	$header_size = curl_getinfo($ch,CURLINFO_HEADER_SIZE);
	$xml = substr($result, $header_size );
	curl_close($ch);

	return $xml;

}

function GetLowestCost($rateXML)
{
	//strip out the default namespace to make the XPath example easier to understand - in a productiosystem you'd want to parse the XML with a
	//more robust method
	$xmlString = str_replace('xmlns="http://www.echo.com/"', '', $rateXML);
	$domObj = new DOMDocument();
	$domObj->loadXML($xmlString);
	$xPath = new DOMXPath($domObj);

	$retValues = array();

	$carrier = $xPath->query('//RateDetail[not(Charges/TotalCharge <= preceding-sibling::RateDetail/Charges/TotalCharge)and not(Charges/TotalCharge <= following-sibling::RateDetail/Charges/TotalCharge)]/Carrier/CarrierName');
	$charge = $xPath->query('//RateDetail[not(Charges/TotalCharge <= preceding-sibling::RateDetail/Charges/TotalCharge)and not(Charges/TotalCharge <= following-sibling::RateDetail/Charges/TotalCharge)]/Charges/TotalCharge');

	$retValues["carrier"] = $carrier;
	$retValues["cost"] = $charge;

	return $retValues;
}

function show_php($var,$indent='&nbsp;&nbsp;',$niv='0')
{
	$str='';
	if(is_array($var))
	{
		$str.= "<b>[array][".count($var)."]</b><br />";
		foreach($var as $k=>$v)
		{
			for($i=0;$i<$niv;$i++) $str.= $indent;
			$str.= "$indent<em>\"{$k}\"=></em>";
			$str.=show_php($v,$indent,$niv+1);
		}
	}
	else if(is_object($var)) {
		$str.= "<b>[object]-class=[".get_class($var)."]-method=[";
		$arr = get_class_methods($var);
		
		foreach ($arr as $method) {
			$str .= "[function $method()]";
		}
		
		$str.="]-";
		$str.="</b>";
		$str.=show_php(get_object_vars($var),$indent,$niv+1);
	}
	else {
		$str.= "<em>[".gettype($var)."]</em>=[{$var}]<br />";
	}
	return($str);
}

?>

<html>
<head>
<title>Echo PHP Rating Demo</title>
	<style type="text/css">
	*{
		font-family: arial, sans-serif;
	}
	
	form
	{
		width: 50%;
	}
	
	fieldset
	{
		width: 550px;
		padding: 5px 0;
	}
	
	fieldset label
	{
		float: left;
		width: 150px;
		margin-right: 15px;
	}
	</style>
</head>
<body>
<h1>Echo PHP Rating Demo</h1>
<p>
Enter values into the appropriate boxes then click the "rate" button. The lowest cost carrier will
be displayed.
</p>
<?php
if ($_POST)
{
	
	$raterXML = GetRate();
	$lowestCarrier = GetLowestCost($raterXML);

	if (!is_null($lowestCarrier))
	{

		$carrier = $lowestCarrier['carrier'];
		$cost = $lowestCarrier['cost'];

		if (!is_null($carrier->item(0)) or !is_null($cost->item(0)))
		{
			echo sprintf('<h2>Rate Results:</h2><p>Lowest Carrier: <strong>%s</strong><br>Charge:
			$<strong>%s</strong></p>',$lowestCarrier['carrier']->item(0)->nodeValue, $lowestCarrier['cost']->item(0)->nodeValue);
		}
		
		print_r($_POST);
		//print_r($raterXML);
		
	}
	else
	{
		echo '<p>No carriers found for the specified lane</p>';
	}

}


?>
<form method="post" action="sample.php">
	<fieldset>
		<strong>All fields are required</strong>
		<p>
			<label for="username">User ID:</label>
			<input type="text" name="username" id="username"></input>
		</p>
		<p>
			<label for="password">Password:</label>
			<input type="text" name="password"></input>
		</p>
		<p>
			<label for="weight">Weight:</label>
			<input type="text" name="weight" />
		</p>
		<p>
			<label for="class">Class:</label>
			<input type="text" name="class" />
		</p>
		<p>
			<label for="origin">Origin ZIP:</label>
			<input type="text" name="origin" />
		</p>
		<p>
			<label for="destination">Destination ZIP:</label>
			<input type="text" name="destination" />
		</p>
	</fieldset>
	<input type="submit" value="Rate it" />
</form>
</body>
</html>