<?php
	$menu = array(
		'Home' => array(
			'link' => 'index.php',
			'submenu_title' => 'Home Menu',
			'submenu' => array(
				'index.php' => 'Home',
				'news.php' => 'News Articles',
				'mysql_status.php' => 'Database Status',
				'layout.php' => 'Example Layout',
				'import.php' => 'Import Products'
			)
		),
		
		'EcoCompass CMS' => array(
			'link' => 'cms.php',
			'submenu_title' => 'CMS Menu',
			'submenu' => array(
				'email_templates.php' => 'E-mail Templates',
				'documents.php' => 'Documents',
				'static_pages.php' => 'Static Pages',
				'cms.php?p=aboutus' => 'About Us',
				'cms.php?p=terms' => 'Terms of Use',
				'cms.php?p=privacy' => 'Privacy Policy',
				'cms.php?p=sponsor' => 'Sponsor Policy',
				'cms.php?p=sitemap' => 'Site Map',
				'cms.php?p=linktous' => 'Link to Us',
				'cms.php?p=careers' => 'Careers',
				'cms.php?p=advertise' => 'Advertise With Us',
				'cms.php?p=corporate' => 'EcoCompass Corporate',
				'cms.php?p=newsletter' => 'Newsletter'
			)
		),
		
		'Users' => array(
			'link' => 'user_summary.php',
			'submenu_title' => 'User Menu',
			'submenu' => array(
				'user_summary.php' => 'Quick Summary',
				'accounts.php' => 'Accounts: All',
				'accounts_admin.php' => 'Accounts: Admin',
				'accounts_homeowner.php' => 'Accounts: Homeowner',
				'accounts_integrator.php' => 'Accounts: Integrator',
				'accounts_supplier.php' => 'Accounts: Manufacturer',
				'mass_email.php' => 'Mass E-Mail'
//				'account_edit.php' => 'Account Edit',

			)
		),
		
		'Manufacturers' => array(
			'link' => 'categories.php',
			'submenu_title' => 'Manufacturers Menu',
			'submenu' => array(
				'categories.php' => 'Categories',
				'attributes.php' => 'Attributes'
			)
		),

		'Installers' => array(
			'link' => 'specialties.php',
			'submenu_title' => 'Specialties Menu',
			'submenu' => array(
				'specialties.php' => 'Specialties',
				'licenses.php' => 'Licenses',
				'certifications.php' => 'Certifications',
				'issuers.php' => 'Certification Issuers'
			)
		)
		
	);
	
	$current_file = end(explode('/', $_SERVER['REQUEST_URI']));
	if(empty($current_file)) $current_file = "index.php";
	if(strpos($current_file, '?') !== false) { 
		$current_file = substr($current_file, 0, strpos($current_file, '?'));
	}
?>		
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
	<title>Admin</title>
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
	<style media="all" type="text/css">@import "../css/admin/all.css";</style>
	<script type="text/javascript" src="<?php echo $site_path; ?>scripts/jquery.js"></script>
	<script type="text/javascript" src="<?php echo $site_path; ?>scripts/jquery.event.drag.min.js"></script>
	<script type="text/javascript" src="<?php echo $site_path; ?>scripts/jquery.wysiwyg.js"></script>
	<script type="text/javascript" src="<?php echo $site_path; ?>scripts/ajaxfileupload.js"></script>
	<link rel="stylesheet" href="<?php echo $site_path; ?>css/jquery.wysiwyg.css" type="text/css" />
</head>
<body>
<div id="main">
	<div id="header">
		<h1>EcoCompass Administration</h1>
		<ul id="top-navigation">
			
			<?php
				// This part "saves" the view for pages which aren't directly associated in the menu with a tab/submenu
				$x_menu = '';
				foreach($menu as $label => $m) { 
					if(isset($m['submenu']) && array_key_exists($current_file, $m['submenu']) || $current_file == $m['link']) {
						$x_menu = $label;
					}
				}
				
				if(!$x_menu && isset($_SESSION['admin_last_my_menu'])) { 
					$x_menu = $_SESSION['admin_last_my_menu'];
				}
							
				// This prints the menu, and stores the tab in the session so it can be restored (above) in case we can't match one
				foreach($menu as $label => $m) { 
					if(isset($m['submenu']) && array_key_exists($current_file, $m['submenu']) || $x_menu == $label) {
						$active = ' class="active"';
						$my_menu = $label;
						$_SESSION['admin_last_my_menu'] = $my_menu;
					} else {
						$active = '';
					}
					echo '<li', $active, '><span><span><a href="', $m['link'], '">', $label, '</a></span></span></li>';
				}				
			?>
		</ul>
	</div>
	<div id="middle">
		<div id="left-column">
			<h3><?php echo $menu[$my_menu]['submenu_title']; ?></h3>
			<ul class="nav">
				<?php
					
					// Same deal as above, look ahead and see if we can find a menu entry for the file
					// If not, use the last one available (in the SESSION)
					// If so, save it for next page view
					
					$last = end($menu[$my_menu]['submenu']);
					foreach($menu[$my_menu]['submenu'] as $link => $title) {
						echo '<li';
						if($last == $title) { echo ' class="last"'; }
						if($current_file == $link) { echo ' class="current"'; }
						echo '><a';
						if($current_file == $link) { echo ' class="current"'; }
						echo ' href="', $link, '">', $title, '</a></li>';
					}
				?>
			</ul>
			<a href="account_edit.php" class="link">My Account</a>
			<a href="../logout.php" class="link">Logout</a>
		</div>
		
		<div id="center-column">
