<?php
class ProductsManagement
{
	public function GetAllTypes()
	{
		global $_DB_LAYER;
		$aplianceTypes=$_DB_LAYER->QueryToArray("SELECT app_t_name,fields FROM appliance_type");
		$conversion=array();
		$conversion['kwh_year']=1;
		$conversion['therms_year']=4;
		$conversion['btuh']=7;
		$conversion['watts']=9;
		for($i=0;$i<count($aplianceTypes);$i++)
		{
			$fieldsInfo=explode(',',$aplianceTypes[$i]->Fields);
			$total=0;
			foreach($fieldsInfo as $key=>$type)
			{
				$total+=$conversion[$type];	
			}
			$aplianceTypes[$i]->Requirements=$total;;
		}
		
		return $aplianceTypes;
	}
	public function GetProductInfo($productId)
	{
		global $_DB_LAYER;
		$product=$_DB_LAYER->GetQueryResult("SELECT * FROM vendor_appliance WHERE v_app_id=".mysql_escape_string($productId));
		if(!$product)
			return false;
		$fields=explode('|',$product->Data);
		foreach($fields as $key=>$field)
		{
			$tmp=explode('=',$field);
			switch($tmp[0])
			{
				case 'kwh_year':
					$product->KWH_Year=$tmp[1];
					break;
				case 'therms_year':
					$product->Therms_Year=$tmp[1];
					break;
				case 'btuh':
					$product->BTUH=$tmp[1];
					break;
				case 'watts':
					$product->Watts=$tmp[1];
					break;
			}
		}
		return $product;
	}
	public function SaveProduct($title,$type,$make,$model,$modelNumber,$price,$kwY,$tY,$btu,$watts,$requirements,$picture,$details)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$data="";
	
		switch($requirements)
		{
			case 1:
				$data="kwh_year=$kwY";
				break;
			case 4:
				$data="therms_year=$tY";
				break;
			case 7:
				$data="btuh=$btu";
				break;
			case 9:
				$data="watts=$watts";
				break;
			case 5:
				$data="kwh_year=$kwY|therms_year=$tY";
				break;
			case 8:
				$data="kwh_year=$kwY|btuh=$btu";
				break;
			case 10:
				$data="kwh_year=$kwY|watts=$watts";
				break;
			case 11:
				$data="therms_year=$tY|btuh=$btu";
				break;
			case 13:
				$data="therms_year=$tY|watts=$watts";
				break;
			case 16:
				$data="btuh=$btu|watts=$watts";
				break;
			case 12:
				$data="btuh=$btu|kwh_year=$kwY|therms_year=$tY";
				break;
			case 17:
				$data="btuh=$btu|kwh_year=$kwY|watts=$watts";
				break;
			case 20:
				$data="btuh=$btu|kwh_year=$kwY|watts=$watts|therms_year=$tY";
				break;
			
		}
			
		return $_DB_LAYER->PerformQuery("INSERT INTO vendor_appliance(user_id,title,price,data,appliance_type,make,model,model_number,details,main_picture) VALUES('".$_SESSION['user_id']."','".mysql_escape_string($title)."','".mysql_escape_string($price)."','".mysql_escape_string($data)."','".mysql_escape_string($type)."','".mysql_escape_string($make)."','".mysql_escape_string($model)."','".mysql_escape_string($modelNumber)."','".mysql_escape_string($details)."','".mysql_escape_string($picture)."')");
	}
	public function UpdateProduct($productID,$title,$type,$make,$model,$modelNumber,$price,$kwY,$tY,$btu,$watts,$requirements,$picture,$details)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$data="";
		switch($requirements)
		{
			case 1:
				$data="kwh_year=$kwY";
				break;
			case 4:
				$data="therms_year=$tY";
				break;
			case 7:
				$data="btuh=$btu";
				break;
			case 9:
				$data="watts=$watts";
				break;
			case 5:
				$data="kwh_year=$kwY,therms_year=$tY";
				break;
			case 8:
				$data="kwh_year=$kwY,btuh=$btu";
				break;
			case 10:
				$data="kwh_year=$kwY,watts=$watts";
				break;
			case 11:
				$data="therms_year=$tY,btuh=$btu";
				break;
			case 13:
				$data="therms_year=$tY,watts=$watts";
				break;
			case 16:
				$data="btuh=$btu,watts=$watts";
				break;
			case 12:
				$data="btuh=$btu,kwh_year=$kwY,therms_year=$tY";
				break;
			case 17:
				$data="btuh=$btu,kwh_year=$kwY,watts=$watts";
				break;
			case 20:
				$data="btuh=$btu,kwh_year=$kwY,watts=$watts,therms_year=$tY";
				break;
			
		}
		
		return $_DB_LAYER->PerformQuery("UPDATE vendor_appliance SET title='".mysql_escape_string($title)."',price='".mysql_escape_string($price)."',data='".mysql_escape_string($data)."',appliance_type='".mysql_escape_string($type)."',make='".mysql_escape_string($make)."',model='".mysql_escape_string($model)."',model_number='".mysql_escape_string($modelNumber)."',details='".mysql_escape_string($details)."',main_picture='".mysql_escape_string($picture)."' WHERE user_id='".$_SESSION['user_id']."' AND v_app_id='".mysql_escape_string($productID)."'");
	}
	
	public function GetMyProducts()
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		
		$myProducts=$_DB_LAYER->QueryToArray("SELECT DISTINCT appliance_type AS APPLIANCE FROM vendor_appliance WHERE user_id='".$_SESSION['user_id']."'");
		if(is_array($myProducts))
		{
			for($i=0;$i<count($myProducts);$i++)
			{
				$myProducts[$i]->Products=$_DB_LAYER->QueryToArray("SELECT v_app_id as ID,title,price,make,model,model_number,main_picture FROM vendor_appliance WHERE user_id='".$_SESSION['user_id']."' AND appliance_type='".$myProducts[$i]->Appliance."'");
			}
		}
		
		return $myProducts;
	}
	public function DropProduct($productId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$result=$_DB_LAYER->PerformQuery("DELETE FROM vendor_appliance WHERE v_app_id='".mysql_escape_string($productId)."' AND user_id='".mysql_escape_string($_SESSION['user_id'])."'");
		if($result)
			$_DB_LAYER->PerformQuery("DELETE FROM SHOPPING_CART WHERE V_APP_ID='".mysql_escape_string($productId)."'");
		return $result;
	}
	public function GetProduct($productID)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->GetQueryResult("SELECT * FROM vendor_appliance WHERE v_app_id='".mysql_escape_string($productID)."' AND user_id='".mysql_escape_string($_SESSION['user_id'])."'");
	}

}
?>