<?php
class ProjectsManagement
{
	public function GetOpenProjects()
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return array();
		$projects=$_DB_LAYER->QueryToArray("SELECT PROJECT_ID,PROJECT_NAME,CREATION_DATE,INSTALL_DATE,NEED_HELP FROM PROJECTS WHERE PROJECT_STATUS='open' ORDER BY PROJECT_ID ASC");
		foreach($projects as $key=>$value)
		{
			$projectBids=$_DB_LAYER->GetQueryResult("SELECT COUNT(BID_ID) AS BIDS FROM PROJECT_BIDS WHERE PROJECT_ID=".$value->Project_Id);
			$projects[$key]->Bids=(is_numeric($projectBids->Bids)&&$projectBids->Bids>0)?$projectBids->Bids:0;
		}
		return $projects;
	}
	
	public function PlaceBid($projectID,$estimatedTime,$timeMeasure,$amount,$message)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$bidToPlace=new Row_Instance(array());
		$bidToPlace->Project_Id=$projectID;
		$bidToPlace->User_Id=$_SESSION['user_id'];
		$bidToPlace->Bid_Date=time();
		$bidToPlace->Bid_Estimated_Time=$estimatedTime;
		$bidToPlace->Bid_Estimated_Time_Measure=$timeMeasure;
		$bidToPlace->Bid_Amount=$amount;
		$bidToPlace->Bid_Description=$message;
		$bidToPlace->Bid_Status='pending';
		return $_DB_LAYER->InsertObject("PROJECT_BIDS",$bidToPlace);
		
	}
	public function GetProjectDetails($projectId,$includeBids=false)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$project=$_DB_LAYER->GetQueryResult("SELECT p.*,u.fname AS OWNER_NAME,u.lname AS OWNER_LASTNAME FROM PROJECTS p,user u WHERE p.USER_ID=u.user_id AND p.PROJECT_ID=".mysql_escape_string($projectId));
		if(!$project)
			return false;
		$projectProducts=$_DB_LAYER->QueryToArray("SELECT * FROM vendor_appliance WHERE v_app_id IN (SELECT V_APP_ID FROM PROJECTS_PRODUCTS WHERE PROJECT_ID=".mysql_escape_string($projectId).")");
		$products=array();
		if(count($projectProducts)>0)
		{
			foreach($projectProducts as $key=>$product)
			{
				$products[]=$product->V_APP_ID;
			}
		}
		$project->Products=$products;
		$project->ProductsList=$projectProducts;
		
		if($includeBids)
			$project->Bids=$_DB_LAYER->QueryToArray("SELECT * FROM PROJECT_BIDS WHERE PROJECT_ID=".mysql_escape_string($projectId)." AND USER_ID=".$_SESSION['user_id']);
		return $project;
	}
	public function SendMessage($bidId,$message)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->PerformQuery("INSERT INTO BID_COMMENTS(BID_ID,USER_ID,COMMENT_DATE,COMMENT) VALUES(".mysql_escape_string($bidId).",".$_SESSION['user_id'].",".time().",'".mysql_escape_string($message)."')");
	}
	public function GetBidDetails($bidId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$bid=$_DB_LAYER->GetQueryResult("SELECT pb.*,p.PROJECT_NAME,u.fname AS OWNER_NAME,u.lname AS OWNER_LASTNAME FROM PROJECT_BIDS pb,PROJECTS p,user u WHERE pb.BID_ID=".mysql_escape_string($bidId)." AND pb.PROJECT_ID=p.PROJECT_ID AND u.user_id=p.USER_ID");
		if(!$bid)
			return false;
		$bid->Comments=$_DB_LAYER->QueryToArray("SELECT * FROM BID_COMMENTS WHERE BID_ID=".$bid->Bid_Id);
		
		return $bid;
	}
	public function GetMyBids()
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return array();
		return $_DB_LAYER->QueryToArray("SELECT pb.*,p.PROJECT_NAME FROM PROJECT_BIDS pb,PROJECTS p WHERE pb.USER_ID=".$_SESSION['user_id']." AND pb.PROJECT_ID=p.PROJECT_ID ORDER BY pb.BID_DATE DESC");
	}
	public function RemoveBid($bidId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->PerformQuery("DELETE FROM PROJECT_BIDS WHERE BID_ID=".mysql_escape_string($bidId)." AND USER_ID=".$_SESSION['user_id']." AND BID_STATUS<>'accepted'");
	}
	
	public function GetProjectOwnerInfo($projectId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->GetQueryResult("SELECT p.PROJECT_NAME,u.email FROM PROJECTS p,user u WHERE p.USER_ID=u.user_id AND p.PROJECT_ID=".mysql_escape_string($projectId));
	}
	public function GetProjectOwnerInfoByBid($bidId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->GetQueryResult("SELECT p.PROJECT_NAME,u.email FROM PROJECTS p,user u WHERE p.USER_ID=u.user_id AND p.PROJECT_ID IN (SELECT PROJECT_ID FROM PROJECT_BIDS WHERE BID_ID".mysql_escape_string($bidId).")");
	}
}
?>