<?php
class SearchManagement
{
	private $_dateFrom;
	private $_dateTo;
	private $_keywords;
	private $_address;
	private $_city;
	private $_state;
	private $_miles;
	private $_postcode;
	private $_matchKind;
	
	public function __construct($postedVars=array())
	{ 
		$dateFrom=explode('/',$postedVars['installFrom']);
		$this->_dateFrom=(count($dateFrom)==3)?mktime(0,0,0,$dateFrom[0],$dateFrom[1],$dateFrom[2]):0;
		$dateTo=explode('/',$postedVars['installTo']);
		$this->_dateTo=(count($dateTo)==3)?mktime(0,0,0,$dateTo[0],$dateTo[1],$dateTo[2]):100000000000000000000;
		$this->_keywords=mysql_escape_string($postedVars['searchKeywords']);
		$this->_matchKind=($postedVars['keywordsMatch']=='all'||$postedVars['keywordsMatch']=='any'||$postedVars['keywordsMatch']=='exact')?$postedVars['keywordsMatch']:'any';
		$this->_address=mysql_escape_string($postedVars['locationLike']);
		$this->_city=mysql_escape_string($postedVars['locationCity']);
		$this->_state=mysql_escape_string($postedVars['locationState']);
		$this->_miles=mysql_escape_string($postedVars['radiousMiles']);
		$this->_postcode=mysql_escape_string($postedVars['locationPostcode']);
	}
	
	public function __get($property)
	{
		switch(strtolower($property))
		{
			case "installfrom":
				return ($this->_dateFrom==0)?"":date('m/d/Y',$this->_dateFrom);
				break;
			case "installto":
				return ($this->_dateTo==100000000000000000000)?"":date('m/d/Y',$this->_dateTo);
				break;
			case "keywordsmatch":
				return $this->_matchKind;
				break;
			case "searchkeywords":
				return $this->_keywords;
				break;			
			case "locationlike":
				return $this->_address;
				break;
			case "locationcity":
				return $this->_city;
				break;
			case "locationstate":
				return $this->_state;
				break;
			case "radiousmiles":
				return $this->_miles;
				break;
			case "locationpostcode":
				return $this->_postcode;
				break;
			case "isadvanced":
				return $this->_dateFrom!=0||$this->_dateTo!=100000000000000000000||$this->_address!=""||$this->_city!=""||$this->_state!=""&&$this->_miles!=""||$this->_postcode!='';
				break;
			
		}
		
	}
	public function SaveInSession()
	{
		$postedVars=array();
		$postedVars['installFrom']=$this->InstallFrom;
		$postedVars['installTo']=$this->InstallTo;
		$postedVars['searchKeywords']=$this->_keywords;
		$postedVars['keywordsMatch']=$this->_matchKind;
		$postedVars['locationLike']=$this->_address;
		$postedVars['locationCity']=$this->_city;
		$postedVars['locationState']=$this->_state;
		$postedVars['radiousMiles']=$this->_miles;
		$postedVars['locationPostcode']=$this->_postcode;
		$_SESSION["searchConfig"]=$postedVars;
	}
	
	public function GetResults()
	{
		global $_DB_LAYER;
		$matchQuery.="PROJECT_STATUS='open' AND INSTALL_DATE>='$this->_dateFrom' AND INSTALL_DATE<='$this->_dateTo'";
		
		if($this->_keywords!="")
		{
			switch($this->_matchKind)
			{
				case 'exact':
					$matchQuery.=" AND (PROJECT_NAME LIKE '%".mysql_escape_string($this->_keywords)."%' OR PROJECT_INFORMATION LIKE '%".mysql_escape_string($this->_keywords)."%')";
					break;
				case 'all':
					$keys=explode(' ',$this->_keywords);
					$subquery="";
					foreach($keys as $key=>$keyword)
					{
						$subquery.=" AND (PROJECT_NAME LIKE '%".mysql_escape_string($keyword)."%' OR PROJECT_INFORMATION LIKE '%".mysql_escape_string($keyword)."%')";
					}
					$matchQuery.=$subquery;
					break;
				case 'any':
					$keys=explode(' ',$this->_keywords);
					$subquery="";
					foreach($keys as $key=>$keyword)
					{
						$subquery.=($subquery=="")?"":" OR ";
						$subquery.="PROJECT_NAME LIKE '%".mysql_escape_string($keyword)."%' OR PROJECT_INFORMATION LIKE '%".mysql_escape_string($keyword)."%'";
					}
					$matchQuery.=" AND ($subquery)";
					break;
			}
		}
		
		if($this->_address!="")
			$matchQuery.=" AND (PROJECT_ADDRESS_LINE1 LIKE '%$this->_address%' OR PROJECT_ADDRESS_LINE2 LIKE '%$this->_address%')";
		if($this->_city!="")
			$matchQuery.=" AND PROJECT_CITY LIKE '%$this->_city%'";
		if($this->_state!="")
			$matchQuery.=" AND PROJECT_STATE LIKE '%$this->_state%'";
		if($this->_postcode!=""&&is_numeric($this->_miles)&&$this->_miles>0)
		{
				$postcodeInfo=$_DB_LAYER->GetQueryResult("SELECT LATITUDE,LONGITUDE FROM US_STATES WHERE ZIP_CODE=".mysql_escape_string($this->_postcode));
				if($postcodeInfo)
					$matchQuery.=" AND PROJECT_POSTCODE IN (SELECT ZIP_CODE FROM US_STATES WHERE (((ACOS( SIN( ( ".$postcodeInfo->Latitude." * PI( ) /180 ) ) * SIN( (LATITUDE * PI( ) /180 ) ) + COS( ( ".$postcodeInfo->Latitude." * PI( ) /180 ) ) * COS( (LATITUDE * pi( ) /180 )) * COS( ((".$postcodeInfo->Longitude." - LONGITUDE) * PI( ) /180 )))) *180 / PI()) *60 * 1.1515)<".$this->_miles.")";
		}
		
		$projects=$_DB_LAYER->QueryToArray("SELECT PROJECT_ID,PROJECT_NAME,CREATION_DATE,INSTALL_DATE,NEED_HELP FROM PROJECTS WHERE $matchQuery ORDER BY PROJECT_ID ASC");
		foreach($projects as $key=>$value)
		{
			$projectBids=$_DB_LAYER->GetQueryResult("SELECT COUNT(BID_ID) AS BIDS FROM PROJECT_BIDS WHERE PROJECT_ID=".$value->Project_Id);
			$projects[$key]->Bids=(is_numeric($projectBids->Bids)&&$projectBids->Bids>0)?$projectBids->Bids:0;
		}
		return $projects;
		
	}
	
}
?>