<?php
class SupplierProfile
{
	public function GetProfile()
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->GetQueryResult("SELECT u.fname,u.lname,u.email,u.zip_code,u.login_pwd,us.co_name,us.website,us.address_1,us.address_2,us.city,us.state,us.zip_code,us.tel,us.fax FROM user u INNER JOIN user_supplier us ON us.user_id=u.user_id WHERE u.USER_ID=".$_SESSION['user_id']);
	}
	
	public function UpdateProfile($_SUPPLIER)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$passwordUpdate=($_SUPPLIER->New_Password!="")?",login_pwd='".md5($_SUPPLIER->New_Password)."'":"";
		$_DB_LAYER->PerformQuery("START TRANSACTION");
		$userData=array('fname','lname','email','zip_code');
		
		if($_SUPPLIER->New_Password!="")
		{
			$_SUPPLIER->Login_Pwd=md5($_SUPPLIER->New_Password);
			$userData[]='login_pwd';
		}
		$userInstance=$_SUPPLIER->CreateSubClone($userData);
		$_DB_LAYER->UpdateObject("user",$userInstance,array('user_id'=>$_SESSION['user_id']),false);
		if($_DB_LAYER->Error!=0)
		{
			$_DB_LAYER->PerformQuery('ROLLBACK');
			return false;
		}
		$supplierInstance=$_SUPPLIER->CreateSubClone(array('co_name','website','address_1','address_2','city','state','zip_code','tel','fax'));
		$_DB_LAYER->UpdateObject("user_supplier",$supplierInstance,array('user_id'=>$_SESSION['user_id']),false);
		if($_DB_LAYER->Error!=0)
		{
			$_DB_LAYER->PerformQuery('ROLLBACK');
			return false;
		}
		$_DB_LAYER->PerformQuery('COMMIT');
		return true;
	}
	
	public function GetOrders()
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$ordersData=$_DB_LAYER->QueryToArray("SELECT ORDER_ID,ORDER_STATUS,DATE_PLACED FROM ORDERS WHERE ORDER_STATUS<>'not-paid' AND ORDER_ID IN (SELECT ORDER_ID FROM ORDER_PRODUCTS WHERE V_APP_ID IN (SELECT v_app_id FROM vendor_appliance WHERE user_id=".$_SESSION['user_id']."))");
		if(is_array($ordersData))
		{
			foreach($ordersData as $key=>$order)
			{
				$orderTotals=$_DB_LAYER->GetQueryResult("SELECT SUM(TOTAL) AS TOTAL,SUM(ECOCOM_FEE) AS ECOCOM_FEE FROM ORDER_PRODUCTS WHERE ORDER_ID=".$order->Order_Id." AND V_APP_ID IN (SELECT v_app_id FROM vendor_appliance WHERE user_id=".$_SESSION['user_id'].") GROUP BY ORDER_ID");
				$ordersData[$key]->Total=$orderTotals->Total;
				$ordersData[$key]->Ecocom_Fee=$orderTotals->Ecocom_Fee;
				
				
			}
		}
		
		return $ordersData;
	}
	
	public function GetOrderData($orderId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$orderData=$_DB_LAYER->GetQueryResult("SELECT * FROM ORDERS WHERE ORDER_ID=".mysql_escape_string($orderId));
		if(!$orderData)
		{
			return false;
		}
		
		$orderData->Products=$_DB_LAYER->QueryToArray("SELECT op.*,vp.title FROM ORDER_PRODUCTS op,vendor_appliance vp WHERE op.V_APP_ID=vp.v_app_id AND op.ORDER_ID=".mysql_escape_string($orderId)." AND vp.user_id=".$_SESSION['user_id']);
		return $orderData;
	}
	
	public function GetOrderLog($orderId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->QueryToArray("SELECT * FROM ORDERS_LOG WHERE ORDER_ID=".mysql_escape_string($orderId)." AND USER_ID=".$_SESSION['user_id']);
	}
	
	public function AddOrderLog($_LOG)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$_LOG->ShippingMethod=($_LOG->ShippingMethod=="")?$_LOG->ShippingMethodOther:$_LOG->ShippingMethod;
		$logData=new Row_Instance(array());
		$logData->Order_Id=$_LOG->OrderId;
		$logData->Log_Date=time();
		$logData->Log_Event="Order status changed to ".ucfirst($_LOG->NewStatus);
		switch($_LOG->NewStatus)
		{
			case "shipped":
				$notes='<b>Shipping service:</b>&nbsp;'.$_LOG->ShippingMethod.'<br><br>';
				$notes.='<b>Tracking number:</b>&nbsp;&nbsp;'.$_LOG->TrackingNumber.'<br><br>';
				$notes.='<b>Tracking URL:</b>&nbsp;&nbsp;&nbsp;&nbsp;'.$_LOG->TrackingURL.'<br><br>';
				$notes.=nl2br($_LOG->UpdateNotes);
				$logData->Supplier_Notes=$notes;
				break;
			default:
				$logData->Supplier_Notes=$_LOG->UpdateNotes;
				break;
		}
		$logData->User_Id=$_SESSION['user_id'];
		if($_DB_LAYER->InsertObject('ORDERS_LOG',$logData)&&$_DB_LAYER->PerformQuery("UPDATE ORDERS SET ORDER_STATUS='".mysql_escape_string($_LOG->NewStatus)."' WHERE ORDER_ID=".mysql_escape_string($_LOG->OrderId)))
		{
			$logData->NewStatus=$_LOG->NewStatus;
			$logData->Products=$_DB_LAYER->QueryToArray("SELECT op.*,vp.title FROM ORDER_PRODUCTS op,vendor_appliance vp WHERE op.V_APP_ID=vp.v_app_id AND op.ORDER_ID=".mysql_escape_string($logData->Order_Id)." AND vp.user_id=".$_SESSION['user_id']);
			$logData->CustomerData=$_DB_LAYER->GetQueryResult("SELECT FIRSTNAME,LASTNAME,EMAIL FROM ORDERS WHERE ORDER_ID=".mysql_escape_string($_LOG->OrderId));
			return $logData;
		}
		return false;
		
		
		
	}
}
?>