<?php
	require '../include/config.php';

	// skipped:
	// 	- ventalating fans
	//  - light commercial heating & cooling
	//  - "air seal and insulate" (no products are listed)
	//  - battery chargers
	//  - all of home electronics & office supplies (except where listed elsewhere)

	$files = array(
		'Room Air Conditioners.txt' => array(
			'type' => 'Room AC',
			// "Brand", "Model", "Reverse Cycle", "Louvered Sides", "Casement", "Capacity (BTU/hour)", "Energy Efficiency Ratio (EER)", "Federal Standard (EER)", "Percent Better", "Active", "Active Date"z
			'fields' => array('make', 'model', 'reverse_cycle', 'louvered_sides', 'casement', 'btuh', 'eer_rating', 'fed_standard_eer', 'percent_better', 'active', 'active_date'),
			'format' => 'csv',
			'skip' => 1
		),

		/* 'Prog_Thermostats.txt' => array(
			'type' => 'Programmable Thermostat',
			'fields' => array('manufacturer', 'make', 'model'),
			'format' => 'tsv',
			'skip' => 6
		), */


		//Organization Name	Brand Name	Model Name	Product Type	COP Rating	EER Rating	Model Number

		'geothermal_heat_pump_prod_list.txt' => array(
			'type' => 'Geothermal Heat Pump',
			'fields' => array('manufacturer', 'make', 'model', 'unit_type', 'cop_rating', 'eer_rating', 'model_number'),
			'format' => 'tsv',
			'skip' => 6
		),

		//Manufacturer Name	Product Family Name	Fuel Type	AFUE Rating	Model Series
		'gas_furnaces_prod_list.txt' => array(
			'type' => 'Gas Furnace',
			'fields' => array('manufacturer', 'make', 'fuel_type', 'afue_rating', 'model'),
			'format' => 'tsv',
			'skip' => 6
		),

		'oil_furnaces_prod_list.txt' => array(
			'type' => 'Oil Furnace',
			'fields' => array('manufacturer', 'make', 'fuel_type', 'afue_rating', 'model'),
			'format' => 'tsv',
			'skip_char' => 1,
			'skip' => 6
		),

		//Manufacturing Company Name	Dehumidifier Type	Brand Name	Model Name	Model Number	Product Capacity (liters/day)	Product Capacity (pints/day)	Energy Factor (L/kWh)
		/* 'dehumid_prod_list.txt' => array(
			'type' => 'Dehumidifier',
			'fields' => array('manufacturer', 'unit_type', 'make', 'model', 'model_number', 'capacity_liters_day', 'capacity_pints_day', 'energy_factor_lkwh'),
			'skip' => 6
		), */

		//Product Type	Manufacturer Name	Brand Name	 Model Name	Model Number	Retailer/SKU Number(s)	Efficiency (CFM/Watt) - Low	Efficiency (CFM/Watt) -  Medium	Efficiency (CFM/Watt) - High	Motor Warranty (Years)	Components Warranty (Year)	Date Available on Market

		/* 'ceiling_fan_only_prod_list-1.txt' => array(
			'type' => 'Ceiling Fan w/o light kit',
			'fields' => array('unit_type', 'manufacturer', 'make', 'model', 'model_number', 'retailer_sku', 'low_cfm_watt', 'medium_cfm_watt', 'high_cfm_watt', 'motor_warranty', 'components_warranty', 'date_available'),
			'skip' => 6
		),

		// Product Type	Manufacturer Name	Brand Name	 Model Name	Model Number	Retailer/SKU Number	Efficiency (CFM/Watt) - Low	Efficiency (CFM/Watt) -  Medium	Efficiency (CFM/Watt) - High	Type of Lighting	Total Input (Watts)	Motor Warranty (Years)	Components Warranty (Years)	Date Available on Market

		'ceiling_fan_with_lightkit_prod_list' => array(
			'type' => 'Ceiling Fan with light kit',
			'fields' => array('unit_type', 'manufacturer', 'make', 'model', 'model_number', 'retailer_sku', 'low_cfm_watt', 'medium_cfm_watt', 'high_cfm_watt', 'lighting_type', 'input_watts', 'motor_warranty', 'components_warranty', 'date_available'),
			'skip' => 6
		),

		//Product Type	Manufacturer Name	Brand Name	 Model Name	Model Number	Retailer/SKU Number	Type of Lighting	Input Power (Watts)	Date Available on Market
		'ceiling_fan_lightkit_only_prod_list.txt' => array(
			'type' => 'Ceiling Fan Light Kit',
			'fields' => array('unit_type', 'manufacturer', 'make', 'model', 'model_number', 'retailer_sku', 'lighting_type', 'input_watts', 'date_available'),
			'skip' => 6,
			'skip_char' => 1
		), */

		//Manufacturer	Brand	Model Number	Indoor Unit Model Number*	Product Type	SEER 	EER	HSPF	Capacity (Btuh)
		'cac_ashp_prod_list-2.txt' => array(
			'type' => 'Central Air Unit',
			'fields' => array('manufacturer', 'make', 'model', 'model_number', 'indoor_unit_model_number', 'unit_type', 'seer_rating', 'eer_rating', 'hspf_rating', 'btuh'),
			'skip' => 4,
			'skip_bottom' => 1
		),

		//Brand Name	Model Name	Boiler Type	Fuel Type	AFUE Rating	Model Number
		/* 'boilers_prod_list-1.txt' => array(
			'type' => 'Boiler',
			'fields' => array('make', 'model', 'unit_type', 'fuel_type', 'afue_rating', 'model_number'),
			'skip' => 6
		), */

		//Manufacturer Name	Brand/Model Name	Model Number	Dust CADR	Tobacco Smoke CADR	Pollen CADR	Dust CADR/Watt	Date Available on the Market
		/* 'room_air_cleaners_prod_list.txt' => array(
			'type' => 'Room Air Cleaner',
			'fields' => array('manufacturer', 'make', 'model', 'dust_cadr', 'tobacco_smoke_cadr', 'pollen_cadr', 'cadr_watt', 'date_available'),
			'skip' => 4
		), */

		//"Brand", "Model", "Configuration", "Defrost Type", "Compact", "Ice", "Volume", "Adjusted Volume", "kWh/year", "Federal Standard (kWh/year)", "Percent Better", "Active", "Active Date"

		'freezers.txt' => array(
			'type' => 'Freezer',
			'fields' => array('make', 'model', 'configuration', 'defrost_type', 'compact', 'ice', 'volume', 'adjusted_volume', 'kwh_year', 'fed_standard_kwh_year', 'percent_better', 'active', 'active_date'),
			'skip' => 1,
			'format' => 'csv'
		),

		// "Brand", "Model", "Configuration", "Defrost Type", "Compact", "Ice", "Volume", "Adjusted Volume", "kWh/year", "Federal Standard (kWh/year)", "Percent Better", "Active", "Active Date"

		'fridge.txt' => array(
			'type' => 'Refrigerator',
			'fields' => array('make', 'model', 'configuration', 'defrost_type', 'compact', 'ice', 'volume', 'adjusted_volume', 'kwh_year', 'fed_standard_kwh_year', 'percent_better', 'active', 'active_date'),
			'skip' => 1,
			'format' => 'csv'
		),

		'dishwashers.txt' => array(
			'type' => 'Dishwasher',
			'type_id' => 12,
			'fields' => array('make','model','size','kwh_year','naeca_std','energy_factor','percent_better','active','active_date'),
			'format' => 'csv',
			'skip' => 1
		),

		// "Brand", "Model", "Volume", "kWh/year", "Modified Energy Factor (MEF)", "Federal Standard (MEF)", "Percent Better", "Water Factor", "Annual Water Use", "Active", "Active Date"

		'clotheswash.txt' => array(
			'type' => 'Washer',
			'type_id' => 6,
			'fields' => array('make', 'model', 'volume', 'kwh_year', 'mef', 'fed_standard_mef', 'percent_better', 'water_factor', 'annual_water_use', 'active', 'active_date'),
			'format' => 'csv',
			'skip' => 1
		),

		//"Brand", "Model", "Fuel Type", "Tank Height (inches)", "Height to Vent (inches)", "Tank Diameter (inches)", "Vent Size (inches)", "Volume (gallons)", "Input (Thousand BTU per hour)", "Energy Factor", "Therms/year (Gas)", "Gallons/year (Propane)", "First Hour Rating (gallons per hour)", "Recovery Efficiency (%)", "Min Warranty-  Tank (years)", "Min Warranty- Parts (years)", "Active", "Active Date"
		'High-Efficiency Gas Storage Water Heaters.txt' => array(
			'type' => 'Gas Storage Water Heater',
			'fields' => array('make', 'model', 'fuel_type', 'tank_height_in', 'height_to_vent_in', 'tank_diameter_in', 'vent_size_in', 'volume_gal', 'input_btuh*1000', 'energy_factor', 'therms_year_gas', 'gallons_year_propane', 'first_hour_rating_gallons_hr', 'recovery_efficiency', 'min_warranty_tank', 'min_warranty_parts', 'active', 'active_date'),
			'format' => 'csv',
			'skip' => 1
		),

		//"Brand", "Model", "Type", "System Type", "Collector Type", "Total Panel Area (cubic feet)", "Solar Fraction", "Solar Energy Factor", "Min Warranty-  Collector (years)", "Min Warranty-  Tank (years)", "Min Warranty-  Controls (years)", "Min Warranty- Parts (years)", "Active", "Active Date"

		'Solar Water Heaters.txt' => array(
			'type' => 'Solar Water Heater',
			'fields' => array('make', 'model', 'type', 'system_type', 'collector_type', 'total_panel_area_ft', 'solar_fraction', 'solar_energy_factor', 'min_warranty_collector', 'min_warranty_tank', 'min_warranty_control', 'min_warranty_parts', 'active', 'active_date'),
			'format' => 'csv',
			'skip' => 1
		),

		//"Brand", "Model", "Fuel Type", "Height (inches)", "Width (inches)", "Depth (inches)", "Min Input (Thousand BTU per hour)", "Max Input (Thousand BTU per hour)", "Energy Factor", "Therms/year (Gas)", "Gallons/year (Propane)", "Max Gallons Per Minute(77&deg;F rise)", "Recovery Efficiency (%)", "Min Warranty-  Heat Exchanger", "Min Warranty- Parts (years)", "Active", "Active Date"

		'Whole-Home Gas Tankless Water Heaters.txt' => array(
			'type' => 'Tankless Gas Water Heater',
			'fields' => array('make', 'model', 'fuel_type', 'height_in', 'width_in', 'depth_in', 'min_input_btu*1000', 'max_output_btu*1000', 'energy_factor', 'therms_year_gas', 'gallons_year_propane', 'max_gal_per_min', 'recovery_efficiency', 'min_warranty_heat_exchanger', 'min_warranty_parts', 'active', 'active_date'),
			'format' => 'csv',
			'skip' => 1
		)
	);

function restack($a) { $a = array_chunk($a, count($a)); return $a[0]; }


$inline_fields = array('make', 'model', 'model_number');
$makers_fields = array('manufacturer', 'make', 'model', 'model_number');

echo '<html><head><style> body { font-family: monospace; } </style></head><body>';
echo '<h1>EnergyStar Database Generator</h1>';


$show_fields = false;

if($show_fields) {
	$all_fields = array();
	foreach($files as $f => $d) {
		foreach($d['fields'] as $field) {
			$all_fields[] = $field;
		}
	}

	$all_fields = array_unique($all_fields);
	asort($all_fields);

	echo '<table width="100%" border="1" cellspacing="0" cellpadding="5">';
	echo '<tr>';
	$x = -1;

	foreach($all_fields as $f) {
	if($x%5 == 4) {
		echo '</tr><tr>';
	}
		echo '<td>', $f, '</td>';
	$x++;
	}
	echo '</tr>';
	echo '</table>';

	die;
}

	echo '<ul>';
	foreach($files as $f => $d) {
		echo "<li>Working on $f<ul>";
		$input = file($f);

		if(empty($d['skip_bottom'])) {
			$d['skip_bottom'] = 0;
		}


		for($x = $d['skip']; $x < (count($input) - $d['skip_bottom']); $x++) {
			$input[$x] = trim($input[$x]);

			if(empty($input[$x])) {
				continue;
			}

			if(empty($d['format'])) {
				$d['format'] = 'tsv';
			}

			if(empty($d['skip_char'])) {
				$d['skip_char'] = 0;
			}

			//$input[$x] = substr($input[$x], $d['skip_char']);


			if($d['format'] == 'tsv') {
				$pieces = explode("\t", $input[$x]);
			} elseif($d['format'] == 'csv') {
				$pieces = explode(",", $input[$x]);
			}

			foreach($pieces as &$p) {
				$p = preg_replace("/[^\x{21}-\x{7E}\s\t\n\r]/", " ", $p);
				$p = trim($p);
			}

			$sql_array = array();
			$data = '';
			$data_array = array();
			/*foreach($d['fields'] as $fk => $field) {
				if(!in_array($field, $inline_fields)) {
					$data .= $field . '=' . $pieces[$fk] . '|';
				} else {
					$sql_array[$field] = $pieces[$fk];
				}
			}*/

			foreach($d['fields'] as $fk => $field) {
				$pieces[$fk] = preg_replace('/^"(.*)"$/', '$1', $pieces[$fk]);
				$data_array[$field] = $pieces[$fk];
			}


			$mkf_val = array();
			foreach($makers_fields as $mkf) {
			@$data_array[$mkf] = trim($data_array[$mkf]);
				if(!empty($data_array[$mkf])) {
					$mkf_val[] = $data_array[$mkf];
					unset($data_array[$mkf]);
				}
			}

			$mkf_val = array_unique($mkf_val);
			$mkf_val = restack($mkf_val);


			if(strpos(strtolower($mkf_val[0]), strtolower($mkf_val[1])) !== false) {
				unset($mkf_val[1]);
			}
			$mkf_val = restack($mkf_val);

			if(strpos(strtolower($mkf_val[1]), strtolower($mkf_val[0])) !== false) {
				unset($mkf_val[0]);
			}
			$mkf_val = restack($mkf_val);

			if(count($mkf_val) == 5) {
				echo "<div style='border: 1px solid #a00'>We have 5 make/model/model_no fields!!!</div>";
			}

			if(count($mkf_val) == 4) {
				unset($mkf_val[0]);
			}
			$mkf_val = restack($mkf_val);


			for($y = 0; $y < count($mkf_val); $y++) {
				$data_array[$makers_fields[$y+1]] = $mkf_val[$y];
			}

			$data = '';
			foreach($data_array as $k => $v) {
				if(!in_array($k, $inline_fields)) {
					$data .= $k . '=' . $v . '|';
				} else {
					$sql_array[$k] = $v;
				}
			}

			//$sql_array['app_t_id'] = $d['type_id'];
			$sql_array['data'] = substr($data, 0, strlen($data) - 1);
			$sql_array['appliance_type'] = $d['type'];

			echo '<li>Inserting ' . $d['type'] . ' > ' . @$data_array['manufacturer'] . ' > ' . @$data_array['make'] . ' > ' . @$data_array['model'] . ' > ' . @$data_array['model_number'] . '</li>';


			$sql->fromarray('insert', 'appliance', $sql_array);
					}
				echo '</ul></li>';
	}

	echo '</ul></body></html>';

?>