<?php
class OrdersManagement
{
	public function GetTotals($_CART_INFO,$shippingFee=9.99)
	{
		$subtotal=0;
		foreach($_CART_INFO as $key=>$product)
		{
			$subtotal+=$product->Quantity*$product->Price;
		}
		return new Row_Instance(array("subtotal"=>$subtotal,"shipping"=>$shippingFee,"total"=>$subtotal+$shippingFee));
	}
	public function PlaceOrder($_ORDER,$_CART_INFO,$ecocomFee=0.05)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		
		$_ORDER->RemoveKey('step');
		$_ORDER->User_Id=$_SESSION['user_id'];
		$_ORDER->Order_Status='not-paid';
		$_ORDER->Shipping_Fee=9.99;
		$totals=$this->GetTotals($_CART_INFO);
		$_ORDER->Order_Subtotal=$totals->Subtotal;
		$_ORDER->Order_Total=$totals->Total;
		$_ORDER->Date_Placed=time();
		$_DB_LAYER->PerformQuery('START TRANSACTION');		
		$orderID=$_DB_LAYER->InsertObject('ORDERS',$_ORDER);		
		if(!$orderID||$_DB_LAYER->Error!=0)
		{
			$_DB_LAYER->PerformQuery('ROLLBACK');
			return false;
		}
		
		foreach($_CART_INFO as $key=>$product)
		{
			$productInstance=new Row_Instance(array());
			$productInstance->V_APP_ID=$product->Id;
			$productInstance->Order_Id=$orderID;
			$productInstance->Quantity=$product->Quantity;
			$productInstance->Subtotal=$product->Quantity*$product->Price;
			$productInstance->Ecocom_Fee=$ecocomFee*$productInstance->Subtotal;
			$productInstance->Total=$productInstance->Subtotal-$ecocomFee;
			$productInstance->Price=$product->Price;
			$_DB_LAYER->InsertObject('ORDER_PRODUCTS',$productInstance);
			if($_DB_LAYER->Error!=0)
			{
				$_DB_LAYER->PerformQuery('ROLLBACK');
				return false;
			}
		}
		$_DB_LAYER->PerformQuery('COMMIT');
		
		return $orderID;
	}
	public function CompleteOrder($orderId,$_ORDER_DATA)
	{
		global $_DB_LAYER;
		$orderData=$_DB_LAYER->GetQueryResult("SELECT * FROM ORDERS WHERE ORDER_STATUS='not-paid' AND ORDER_ID=".mysql_escape_string($orderId));
		if(!$orderData)
		{
			return false;
		}
		
		$orderToUpdate=new Row_Instance(array("ORDER_STATUS"=>'pending'));
		$orderToUpdate->FirstName=$_ORDER_DATA->x_first_name;
		$orderToUpdate->Lastname=$_ORDER_DATA->x_last_name;
		$orderToUpdate->Phone=$_ORDER_DATA->x_phone;
		$orderToUpdate->Fax=$_ORDER_DATA->x_fax;
		$orderToUpdate->Email=$_ORDER_DATA->x_email;
		$orderToUpdate->Billing_Address=$_ORDER_DATA->x_address;
		$orderToUpdate->Billing_Address=$_ORDER_DATA->x_address;
		$orderToUpdate->Billing_City=$_ORDER_DATA->x_city;
		$orderToUpdate->Billing_State=$_ORDER_DATA->x_state;
		$orderToUpdate->Billing_Country=$_ORDER_DATA->x_country;
		$orderToUpdate->Billing_Postcode=$_ORDER_DATA->x_zip;
		$orderToUpdate->Shipping_Address=$_ORDER_DATA->x_ship_to_address;
		$orderToUpdate->Shipping_City=$_ORDER_DATA->x_ship_to_city;
		$orderToUpdate->Shipping_State=$_ORDER_DATA->x_ship_to_state;
		$orderToUpdate->Shipping_Country=$_ORDER_DATA->x_ship_to_country;
		$orderToUpdate->Shipping_Postcode=$_ORDER_DATA->x_ship_to_zip;
		$orderToUpdate->Company=$_ORDER_DATA->x_company;
		
		if(!$_DB_LAYER->UpdateObject("ORDERS",$orderToUpdate,array("ORDER_ID"=>$orderId)))
			return false;
		$orderToUpdate->User_Id=$_SESSION['user_id'];
		$orderToUpdate->Order_Total=$orderData->Order_Total;
		$orderToUpdate->Order_Subtotal=$orderData->Order_Subtotal;
		$orderToUpdate->Shipping_Fee=$orderData->Shipping_Fee;
		$orderToUpdate->Date_Placed=$orderData->Date_Placed;
		$orderToUpdate->Customer_Notes=$orderData->Customer_Notes;
		$orderToUpdate->Products=$_DB_LAYER->QueryToArray("SELECT op.*,vp.title FROM ORDER_PRODUCTS op,vendor_appliance vp WHERE op.V_APP_ID=vp.v_app_id AND op.ORDER_ID=".mysql_escape_string($orderId));
		$productsIds="";
		foreach($orderToUpdate->Products as $key=>$product)
		{
			$productsIds.=($productsIds=="")?$product->V_App_Id:",".$product->V_App_Id;
		}
		
		$orderToUpdate->Suppliers=$_DB_LAYER->QueryToArray("SELECT DISTINCT email,user_id FROM user WHERE user_id IN (SELECT DISTINCT user_id FROM vendor_appliance WHERE v_app_id IN (SELECT V_APP_ID FROM ORDERS WHERE ORDER_ID=".mysql_escape_string($orderId)."))");
		
		foreach($orderToUpdate->Suppliers as $key=>$supplier)
		{
			$orderToUpdate->Suppliers[$key]->Products=$_DB_LAYER->QueryToArray("SELECT op.*,vp.title FROM ORDER_PRODUCTS op,vendor_appliance vp WHERE op.V_APP_ID=vp.v_app_id AND op.ORDER_ID=".mysql_escape_string($orderId)." AND vp.user_id=".$supplier->User_Id);
		}
		
		$_DB_LAYER->PerformQuery("DELETE FROM SHOPPING_CART WHERE USER_ID=".$orderToUpdate->User_Id);
		return $orderToUpdate;
	}
	
	public function ValidateOrder($_ORDER_DATA,$apiLoginId="",$md5Hash="")
	{
		global $_DB_LAYER,$avserr,$cvverr,$cavverr,$err;
		$orderData=$_DB_LAYER->GetQueryResult("SELECT * FROM ORDERS WHERE ORDER_STATUS='not-paid' AND ORDER_ID=".mysql_escape_string($_ORDER_DATA->X_PO_NUM)." AND USER_ID=".mysql_escape_string($_ORDER_DATA->X_CUST_ID));
		if(!$orderData)
			return new Row_Instance(array("error"=>true,"message"=>"No order found to be processed"));
		if($_ORDER_DATA->X_Response_Code!='1')
			return new Row_Instance(array("error"=>true,"message"=>$err[$_ORDER_DATA->X_Response_Reason_Text]));
		if($_ORDER_DATA->X_Amount!=$orderData->Order_Total)
			return new Row_Instance(array("error"=>true,"message"=>"Amount paid doesn't correspond to order's total."));
		if($_ORDER_DATA->X_Method!='CC')
			return new Row_Instance(array("error"=>true,"message"=>"The payment method used isn't supported by our system."));
		if($_ORDER_DATA->X_CAVV_Response!='2')
			return new Row_Instance(array("error"=>true,"message"=>"Card CAVV: ".$cavverr[$_ORDER_DATA->X_CAVV_Response]));
		if(strtolower(md5($md5Hash.$apiLoginId.$_ORDER_DATA->X_Trans_Id.$_ORDER_DATA->X_Amount))!=strtolower($_ORDER_DATA->X_MD5_Hash))
			return new Row_Instance(array("error"=>true,"message"=>"Card CVV2: Invalid transaction"));
		return new Row_Instance(array("error"=>false));
	}
}
?>