<?php
class SearchManagement
{
	private $_priceFrom;
	private $_priceTo;
	private $_keywords;
	private $_sku;
	private $_type;
	private $_brand;
	private $_sortField;
	private $_sortOrientation;
	private $_recordsPerPage;
	private $_currentPage;
	private $_matchKind;
	
	public function __construct($postedVars=array())
	{ 
		
		$this->_priceFrom=(is_numeric($postedVars['priceFrom'])&&$postedVars['priceFrom']>0)?$postedVars['priceFrom']:0;
		$this->_priceTo=(is_numeric($postedVars['priceTo'])&&$postedVars['priceTo']>$this->_priceFrom)?$postedVars['priceTo']:10000000000;
		$this->_keywords=mysql_escape_string($postedVars['searchKeywords']);
		$this->_matchKind=($postedVars['keywordsMatch']=='all'||$postedVars['keywordsMatch']=='any'||$postedVars['keywordsMatch']=='exact')?$postedVars['keywordsMatch']:'any';
		
		$sortData=explode('-',$postedVars['sb']);
		$this->_sortField=($sortData[0]=='price'||$sortData[0]=='date'||$sortData[0]=='brand'||$sortData[0]=='sku'||$sortData[0]=='name')?$sortData[0]:'price';
		$this->_sortOrientation=($sortData[1]=='asc'||$sortData[1]=='desc')?$sortData[1]:'asc';
		$this->_recordsPerPage=(is_numeric($postedVars['resPP'])&&$postedVars['resPP']>0&&$postedVars['resPP']%10==0)?$postedVars['resPP']:20;
		$this->_sku=mysql_escape_string($postedVars['productSku']);
		$this->_type=mysql_escape_string($postedVars['productType']);
		$this->_brand=mysql_escape_string($postedVars['productBrand']);
	}
	public function __set($property,$value)
	{
		switch(strtolower($property))
		{
			case "resultsperpage":
				$this->_recordsPerPage=$value;
				break;
			case "sortfield":
				$this->_sortField=$value;
				break;
			case "sortorientation":
				$this->_sortOrientation=$value;
				break;
		}
	}
	public function __get($property)
	{
		switch(strtolower($property))
		{
			case "pricefrom":
				return $this->_priceFrom;
				break;
			case "priceto":
				return $this->_priceTo;
				break;
			case "keywordsmatch":
				return $this->_matchKind;
				break;
			case "searchkeywords":
				return $this->_keywords;
				break;
			
			case "sortby":
				return $this->_sortField;
				break;
			case "sortorder":
				return $this->_sortOrientation;
				break;
			case "resultsperpage":
				return $this->_recordsPerPage;
				break;
			case "productsku":
				return $this->_sku;
				break;
			case "productbrand":
				return $this->_brand;
				break;
			case "producttype":
				return $this->_type;
				break;
			case "isadvanced":
				return $this->_type!=""||$this->_brand!=""||$this->_sku!=""||$this->_priceFrom>0||$this->_priceTo>0&&$this->priceTo<10000000000||$this->_matchKind!='any';
				break;
			
		}
		
	}
	
	public function ToString($toExcludeField="")
	{
		$postedVars=array();
		$postedVars['priceFrom']=$this->_priceFrom;
		$postedVars['priceTo']=$this->_priceTo;
		$postedVars['searchKeywords']=$this->_keywords;
		$postedVars['keywordsMatch']=$this->_matchKind;
		$postedVars['sb']=$this->_sortField;
		$postedVars['so']=$this->_sortOrientation;
		$postedVars['resPP']=$this->_recordsPerPage;
		$postedVars['productSku']=$this->_sku;
		$postedVars['productBrand']=$this->_brand;
		$postedVars['productType']=$this->_type;
		$result="";
		foreach($postedVars as $key=>$value)
		{
			if($key!=$toExcludeField)
				$result.="&$key=$value";
		}
		return $result;
	}
	public function SaveInSession()
	{
		$postedVars=array();
		$postedVars['priceFrom']=$this->_priceFrom;
		$postedVars['priceTo']=$this->_priceTo;
		$postedVars['searchKeywords']=$this->_keywords;
		$postedVars['keywordsMatch']=$this->_matchKind;
		$postedVars['sb']=$this->_sortField;
		$postedVars['so']=$this->_sortOrientation;
		$postedVars['resPP']=$this->_recordsPerPage;
		$postedVars['productSku']=$this->_sku;
		$postedVars['productBrand']=$this->_brand;
		$postedVars['productType']=$this->_type;
		$_SESSION["searchConfig"]=$postedVars;
	}
	
	public function GetResults($page)
	{
		global $_DB_LAYER;
		$searchFields=array();
		$searchFields[]="title";
		$searchFields[]="price";
		$searchFields[]="appliance_type";
		$searchFields[]="make";
		$searchFields[]="model";
		$searchFields[]="model_number";
		$searchFields[]="main_picture";
		$searchFields[]="v_app_id";
		
		$matchQuery.=" price>='$this->_priceFrom' AND price<='$this->_priceTo'";
		
		if($this->_keywords!="")
		{
			switch($this->_matchKind)
			{
				case 'exact':
					$matchQuery.=" AND (title LIKE '%".mysql_escape_string($this->_keywords)."%' OR details LIKE '%".mysql_escape_string($this->_keywords)."%')";
					break;
				case 'all':
					$keys=explode(' ',$this->_keywords);
					$subquery="";
					foreach($keys as $key=>$keyword)
					{
						$subquery.=" AND (title LIKE '%".mysql_escape_string($keyword)."%' OR details LIKE '%".mysql_escape_string($keyword)."%')";
					}
					$matchQuery.=$subquery;
					break;
				case 'any':
					$keys=explode(' ',$this->_keywords);
					$subquery="";
					foreach($keys as $key=>$keyword)
					{
						$subquery.=($subquery=="")?"":" OR ";
						$subquery.="title LIKE '%".mysql_escape_string($keyword)."%' OR details LIKE '%".mysql_escape_string($keyword)."%'";
					}
					$matchQuery.=" AND ($subquery)";
					break;
			}
		}
		
		if($this->_type!="")
			$matchQuery.=" AND appliance_type='$this->_type'";
		if($this->_brand!="")
			$matchQuery.=" AND make LIKE '%$this->_brand%'";
		if($this->_sku!="")
			$matchQuery.=" AND model_number LIKE '%$this->_sku%'";
		$sortQuery="";
		
		switch($this->_sortField)
		{
			case 'price':
				$sortQuery.=" ORDER BY price";
				break;
			case 'date':
				$sortQuery.=" ORDER BY v_app_id";
				break;
			case 'brand':
				$sortQuery.=" ORDER BY make";
				break;
			case 'sku':
				$sortQuery.=" ORDER BY model_number";
				break;
			case 'name':
				$sortQuery.=" ORDER BY title";
				break;
		}
		
		$sortQuery.=" ".strtoupper($this->_sortOrientation);
		
		$countInfo=$_DB_LAYER->GetQueryResult("SELECT COUNT(v_app_id) AS PRODUCTS FROM vendor_appliance  WHERE $matchQuery",false);
		
		if($countInfo["PRODUCTS"]==0)
		{
			$result=new Row_Instance(array("pages"=>0,"currentPage"=>0,"products"=>array()));
		}
		else
		{
			$total_pages=floor($countInfo["PRODUCTS"]/$this->_recordsPerPage);
			if($countInfo["PRODUCTS"]%$this->_recordsPerPage!=0&&$countInfo["PRODUCTS"]>$this->_recordsPerPage)
				$total_pages++;		
			if($total_pages<=1)
				$page=0;
			else
			{
				while($page>=$total_pages)
				{
					$page--;
				}
			}
			$currentPage=$page;			
			$this->_currentPage=$currentPage;
			$page=$page*$this->_recordsPerPage;
			
			$resultProducts=$_DB_LAYER->QueryToArray("SELECT ".implode(",",$searchFields)." FROM vendor_appliance WHERE $matchQuery $sortQuery LIMIT $page,$this->_recordsPerPage"); 
			if($total_pages==0&&count($resultProducts)>0)
				$total_pages=1;
			
			$result=new Row_Instance(array("pages"=>$total_pages,"currentPage"=>$currentPage,"products"=>$resultProducts));
			
		}
		return $result;
		
	}
	public function GetAllTypes()
	{
		global $_DB_LAYER;
		return $_DB_LAYER->QueryToArray("SELECT name FROM category");
	}
	
}
?>
