<?php
class ProductsManagement
{
	public function GetAllTypes()
	{
		global $_DB_LAYER;
		$categories = $_DB_LAYER->QueryToArray("SELECT * FROM category");
		return $categories;
	}
	
	public function GetProductInfo($productId)
	{
		global $_DB_LAYER;
		$productInfo = $_DB_LAYER->GetQueryResult("
			SELECT
				p.*,
				c.name AS category_name
			FROM
				product p
			LEFT JOIN
				category c
			ON
				c.id = p.cat_id
			WHERE
				p.id = '".mysql_escape_string($productId)."'");
		if(!$productInfo)
			return false;
		
		$productInfo->description = str_replace("<br>\n", "\n", $productInfo->description);
				
		$productAttributes = $_DB_LAYER->QueryToArray("
			SELECT DISTINCT
				a.id,
				a.name,
				av.value,
				ca.id AS cat_att_id,
				ca.class,
				ca.control_type,
				ca.mandatory,
				ca.admin_pos_x,
				ca.admin_pos_y,
				ca.admin_width,
				ca.admin_height
			FROM
				category_attributes ca
			JOIN
				attribute a
			ON
				a.id = ca.att_id
			LEFT JOIN
				attribute_value av
			ON
				av.att_id = a.id AND
				av.prod_id = '".$productInfo->id."'
			WHERE
				ca.cat_id = '".$productInfo->cat_id."'");
		$cat_attributes = array();
		$i = 0;
		foreach ($productAttributes as $attr) {
			$cat_attributes[$i] = array(
				"id" => $attr->id,
				"name" => $attr->name,
				"value" => $attr->value,
				"class" => $attr->class,
				"control_type" => $attr->control_type,
				"mandatory" => $attr->mandatory,
				"admin_pos_x" => $attr->admin_pos_x,
				"admin_pos_y" => $attr->admin_pos_y,
				"admin_width" => $attr->admin_width,
				"admin_height" => $attr->admin_height
				);
			if ($attr->control_type == "combo") {
				$options = $_DB_LAYER->QueryToArray("SELECT name, value FROM allowed_values WHERE cat_att_id = '".$attr->cat_att_id."'");
				$j = 0;
				foreach ($options as $option) {
					$cat_attributes[$i]["options"][$j]["name"] = $option->name;
					$cat_attributes[$i]["options"][$j]["value"] = $option->value;
					$j++;
				}
			}
			$i++;
		}
		$productInfo->cat_attributes = $cat_attributes;
		/*
		$catFeatures = $this->GetCategoryFeatures($productInfo->cat_id);
		$productFeatures = $_DB_LAYER->QueryToArray("
			SELECT
				f.id,
				f.name,
				f.description,
				fv.relevant,
				fv.value,
				cf.id AS cat_feat_id
			FROM
				category_features cf
			JOIN
				feature f
			ON
				f.id = cf.feat_id
			LEFT JOIN
				feature_value fv
			ON
				fv.feat_id = f.id AND
				fv.prod_id = '".$productInfo->id."'
			WHERE
				cf.cat_id = '".$productInfo->cat_id."'");
		$features = array();
		$i = 0;
		foreach ($productFeatures as $feat) {
			if ($catFeatures[$feat->id]) {
				$catFeatures[$feat->id]["relevant"] = $feat->relevant;
				$catFeatures[$feat->id]["value"] = $feat->value;
			}
		}
		$productInfo->cat_features = $catFeatures;
		*/
		return $productInfo;
	}
	
	// Creates a temprorary record in product_temp
	// It's ID is used turned negative in product_upload for the images
	// that have been uploaded for the products that haven't been saved yet.
	// Returns the ID.
	public function InitProduct($user_id) {
		global $_DB_LAYER, $_USER_LOGGED, $site_path, $upload_directory;
		if (!$_USER_LOGGED)
			return false;
		// Let's clean up the old records first
		$outtimed = $_DB_LAYER->QueryToArray("SELECT id FROM product_temp WHERE TIMESTAMPADD(HOUR, 2, timestamp) < NOW()");
		$upswhere = "";
		$path = $_SERVER['DOCUMENT_ROOT'].$site_path.$upload_directory;
		foreach ($outtimed as $prod) {
			if ($notfirst)
				$upswhere .= " OR ";
			else
				$upswhere .= "WHERE ";
			$upswhere .= "prod_id = '-".$prod->id."'";
			foreach (glob($path."p-".$prod->id."*") as $filename) {
				@unlink($filename);
			}
		}
		$_DB_LAYER->PerformQuery("DELETE FROM product_temp WHERE TIMESTAMPADD(HOUR, 2, timestamp) < NOW()");
		if ($upswhere != "")
			$_DB_LAYER->PerformQuery("DELETE FROM product_uploads $upswhere");
		
		$result = $_DB_LAYER->PerformQuery("INSERT INTO product_temp(user_id) VALUES('$user_id')");
		if ($result)
			return mysql_insert_id();
		return false;
	}
	
	public function SaveProduct($tempid, $category, $brand, $model, $price, $description, $attributes, $features)
	{
		global $_DB_LAYER, $_USER_LOGGED, $site_path, $upload_directory;
		if (!$_USER_LOGGED)
			return false;
		$description = str_replace("\n", "<br>\n", $description);		
		$result = $_DB_LAYER->PerformQuery("INSERT INTO product(user_id, cat_id, brand, model, price, description) VALUES('".$_SESSION['user_id']."', '$category', '$brand', '$model', '$price', '$description')");
		if ($result) {
			$path = $_SERVER['DOCUMENT_ROOT'].$site_path.$upload_directory;
			$productId = mysql_insert_id();
			$files = $_DB_LAYER->QueryToArray("SELECT id, filename FROM product_uploads WHERE prod_id = '$tempid'");
			foreach ($files as $file) {
				$filename = $file->filename;
				$id = $file->id;
				list($prefix, $name) = explode("_", $filename, 2);
				$filenamenew = "p".$productId."_".$name;
				if ($_DB_LAYER->PerformQuery("UPDATE product_uploads SET prod_id = '$productId', filename = '$filenamenew' WHERE id = '$id'")) {
					@rename($path.$filename, $path.$filenamenew);
					$description = str_replace($filename, $filenamenew, $description);
				}
			}
			$_DB_LAYER->PerformQuery("UPDATE product SET description = '$description' WHERE id = '$productId'");
			$tempid;
			if (is_array($attributes)) {
				foreach ($attributes as $attribute => $value)
					$_DB_LAYER->PerformQuery("INSERT INTO attribute_value(prod_id, att_id, value) VALUES('$productId', '$attribute', '$value')");
			}
			if (is_array($features)) {
				foreach ($features as $id => $feature)
					$_DB_LAYER->PerformQuery("INSERT INTO feature_value(prod_id, feat_id, relevant, value) VALUES('$productId', '$id', '".($feature["relevant"] ? "1" : "0")."', '".$feature["value"]."')");
			}
			$_DB_LAYER->PerformQuery("DELETE FROM product_temp WHERE id = '$tempid'");
		}
		return $result;
	}
	
	public function UpdateProduct($productId, $category, $brand, $model, $price, $description, $attributes, $features)
	{
		global $_DB_LAYER, $_USER_LOGGED;
		if (!$_USER_LOGGED)
			return false;
		$description = str_replace("\n", "<br>\n", $description);
		$result = $_DB_LAYER->PerformQuery("UPDATE product SET cat_id = '$category', brand = '$brand', model = '$model', price = '$price', description = '$description' WHERE id = '$productId'");
		if ($result) {
			if (is_array($attributes))
				foreach ($attributes as $attribute => $value) {
					$_DB_LAYER->PerformQuery("UPDATE attribute_value SET value = '$value' WHERE prod_id = '$productId' AND att_id = '$attribute'");
					if (!@mysql_num_rows()) {
						$_DB_LAYER->PerformQuery("INSERT INTO attribute_value(prod_id, att_id, value) VALUES('$productId', '$attribute', '$value')");
					}
				}
			if (is_array($features))
				foreach ($features as $id => $feature) {
					$_DB_LAYER->PerformQuery("UPDATE feature_value SET relevant = '".($feature["relevant"] ? "1" : "0")."', value = '".$feature["value"]."' WHERE prod_id = '$productId' AND feat_id = '$id'");
					if (!@mysql_num_rows()) {
						$_DB_LAYER->PerformQuery("INSERT INTO feature_value(prod_id, feat_id, relevant, value) VALUES('$productId', '$id', '".($feature["relevant"] ? "1" : "0")."', '".$feature["value"]."')");
					}
				}
		}
		return $result;
	}
	
	public function GetMyProducts()
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$myProducts = $_DB_LAYER->QueryToArray("
			SELECT
				p.*,
				c.name AS cat_name
			FROM
				product p
			LEFT JOIN
				category c
			ON
				c.id = p.cat_id
			WHERE
				p.user_id='".$_SESSION['user_id']."'
			ORDER BY
				cat_name");
		$output = array();
		if (is_array($myProducts)) {
			$i = -1;
			foreach ($myProducts as $product) {
				if ($output[$i]["cat_name"] != $product->cat_name) {
					$i++;
					$output[$i]["cat_name"] = $product->cat_name;
					$j = 0;
				}
				$output[$i]["products"][$j]["id"] = $product->id;
				$output[$i]["products"][$j]["brand"] = $product->brand;
				$output[$i]["products"][$j]["model"] = $product->model;
				$output[$i]["products"][$j]["price"] = $product->price;
				$j++;
			}
		}
		return $output;
	}
	
	public function DropProduct($productId)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		$result=$_DB_LAYER->PerformQuery("DELETE FROM product WHERE id = '".mysql_escape_string($productId)."'");
		if($result) {
			$_DB_LAYER->PerformQuery("DELETE FROM attribute_value WHERE prod_id = '".mysql_escape_string($productId)."'");
			$_DB_LAYER->PerformQuery("DELETE FROM feature_value WHERE prod_id = '".mysql_escape_string($productId)."'");
			$_DB_LAYER->PerformQuery("DELETE FROM SHOPPING_CART WHERE V_APP_ID='".mysql_escape_string($productId)."'");
		}
		return $result;
	}
	
	public function GetProduct($productID)
	{
		global $_DB_LAYER,$_USER_LOGGED;
		if(!$_USER_LOGGED)
			return false;
		return $_DB_LAYER->GetQueryResult("SELECT * FROM product WHERE id='".mysql_escape_string($productID)."'");
	}
	
	public function CheckMandatoryAttributes($category, $attributes)
	{
		global $_DB_LAYER;
		$mandatory = $_DB_LAYER->QueryToArray("SELECT att_id FROM category_attributes WHERE cat_id = '$category' AND mandatory = '1'");
		foreach ($mandatory as $attr)
			if (!isset($attributes[$attr->att_id]) OR $attributes[$attr->att_id] == "")
				return false;
		return true;
	}
	
	public function GetCategoryAttributes($category) {
		global $_DB_LAYER;
		$categoryAttributes = $_DB_LAYER->QueryToArray("
			SELECT
				a.id,
				a.name,
				ca.id AS cat_att_id,
				ca.control_type,
				ca.mandatory,
				ca.admin_pos_x,
				ca.admin_pos_y,
				ca.admin_width,
				ca.admin_height
			FROM
				category_attributes ca
			JOIN
				attribute a
			ON
				a.id = ca.att_id
			WHERE
				ca.cat_id = '$category'");
		$cat_attributes = array();
		$i = 0;
		foreach ($categoryAttributes as $attr) {
			$cat_attributes[$i] = array(
				"id" => $attr->id,
				"name" => $attr->name,
				"control_type" => $attr->control_type,
				"mandatory" => $attr->mandatory,
				"admin_pos_x" => $attr->admin_pos_x,
				"admin_pos_y" => $attr->admin_pos_y,
				"admin_width" => $attr->admin_width,
				"admin_height" => $attr->admin_height
				);
			if ($attr->control_type == "combo") {
				$options = $_DB_LAYER->QueryToArray("SELECT name, value FROM allowed_values WHERE cat_att_id = '".$attr->cat_att_id."'");
				$j = 0;
				foreach ($options as $option) {
					$cat_attributes[$i]["options"][$j]["name"] = $option->name;
					$cat_attributes[$i]["options"][$j]["value"] = $option->value;
					$j++;
				}
			}
			$i++;
		}
		return $cat_attributes;
	}
	
	public function GetCategoryFeatures($category) {
		global $_DB_LAYER;
		if (!$category)
			return false;
		/*
		$categoryFeatures = $_DB_LAYER->QueryToArray("
			SELECT
				f.id,
				f.name,
				f.description,
				cf.id AS cat_feat_id
			FROM
				category_features cf
			JOIN
				feature f
			ON
				f.id = cf.feat_id
			WHERE
				cf.cat_id = '$category'");
		*/
		$cat_features = array();
		$i = 0;
		/*
		foreach ($categoryFeatures as $feat) {
			$cat_features[$feat->id] = array(
				"id" => $feat->id,
				"name" => $feat->name,
				"description" => $feat->description
				);
			$i++;
		}*/
		return $cat_features;
	}
}
?>
