<?php
/*************************************************************************/
/*	This software has been developed and is property of CodeHid Team     */
/*	All rights are reserved, you are not authorized to use, modify or    */
/*	distribute this software without CodeHid Team's authorization.		 */
/*																		 */
/*	Developer: Nelio Contrera											 */
/*	Coyright CodeHid Team 2008. www.codehid.com                          */
/*************************************************************************/
class Row_Instance
{
	private $_elems;
	public function __construct($elems,$escape=false)
	{
		if(!is_array($elems))
			throw new Exception("#100");
		$this->_elems=array();
		foreach($elems as $key=>$value)
		{
			$this->_elems[strtolower($key)]=($escape==true)?stripslashes($value):$value;
		}
	}

	public function __get($elem_name)
	{
		if(!array_key_exists(strtolower($elem_name),$this->_elems))
			return NULL;
		return $this->_elems[strtolower($elem_name)];
	}

	public function __set($elem_name,$value)
	{
		$this->_elems[strtolower($elem_name)]=$value;
	}

	public function KeyExists($name) {
		return array_key_exists(strtolower($name), $this->_elems);
	}
	public function GetKeys()
	{
		return array_keys($this->_elems);
	}
	public function RemoveKey($key)
	{
		unset($this->_elems[strtolower($key)]);
	}
	public function CreateSubClone($elements=array())
	{
		$result=array();
		foreach($elements as $key=>$value)
		{
			$result[$value]=$this->_elems[strtolower($value)];
		}
		return new Row_Instance($result);
	}
}
?>