<?php
function __autoload($class)
{
	if(is_file("includes/server_side/class/class.$class.php"))
		require_once("includes/server_side/class/class.$class.php");
}
function SaveThumbnail($src,$destination,$source_name,$width,$height)
{
	  $_THUMB_WIDTH=$width;
	  $_THUMB_HEIGHT=$height;
	 
	  $ext = @explode(".", $source_name);
	  $ext = $ext[@count($ext)-1];
	  if(strtolower($ext) == "jpg" || strtolower($ext) == "jpeg")
	      $im = @imagecreatefromjpeg($src);
      else if($ext == "png")
	      $im = @imagecreatefrompng($src);
	  else if($ext == "gif")
	      $im = @imagecreatefromgif($src);
	  else 
	  	  return false;
	 
      $x = @imagesx($im);
      $y = @imagesy($im);
	  if($x > $y&&($x > $_THUMB_WIDTH || $y > $_THUMB_HEIGHT)) 
	  {
	  	  $newx = $_THUMB_WIDTH;
		  $resize_perc=floor(($_THUMB_WIDTH*100)/$x);
		  $newy=ResizeDimensions($y,$_THUMB_HEIGHT,$resize_perc);
	  }
      else if($x > $_THUMB_WIDTH || $y > $_THUMB_HEIGHT)
	  {
	  	  $newy = $_THUMB_HEIGHT;
	      $resize_perc=floor(($_THUMB_HEIGHT*100)/$y);
		  $newx=ResizeDimensions($x,$_THUMB_WIDTH,$resize_perc);
      }
      else
	  {
	  	 
	  	 $newy = $y;
	     $newx = $x;
		
	  }
	  $im2 = @imagecreatetruecolor($newx, $newy);
      @imagecopyresampled($im2, $im, 0, 0, 0, 0, floor($newx), floor($newy), $x, $y);
	  $result=@imagejpeg($im2,$destination);
	  @imagedestroy($im);
	  @imagedestroy($im2);
      return $result;
}
function ResizeImage($max_width,$image)
{
	$image_size=getimagesize($image);

	if($image_size[0]>$image_size[1])
	{
		$width=min($max_width,$image_size[0]);
		$amount=$image_size[0]-$width;
		$percent=(100*$amount)/$image_size[0];
		$height=floor($image_size[1]-(($image_size[1]*$percent)/100));
	} 
	else
	{
		$width=min($max_width,$image_size[0]);
		$amount=$image_size[0]-$width;
		$percent=(100*$amount)/$image_size[0];
		$height=floor($image_size[1]-(($image_size[1]*$percent)/100));
	}
	return array("WIDTH"=>$width,"HEIGHT"=>$height);
}
function FormatPrice($price)
{
	if($price=="")
		return "0.00";
	if(strrpos($price,'.')===false)
		return $price.".00";
	switch(strrpos($price,'.'))
	{
		case strlen($price)-3:
			return $price;
		case strlen($price)-2:
			return $price."0";
		default:
				return "$".substr($price,0,strrpos($price,'.')+2);
				break;							
	}
	
}
function SaveImageResized($filename, $source, $xmax, $ymax,$destination,$escape_gifs=false)
{
	  $ext = @explode(".", $filename);
	  $ext = $ext[@count($ext)-1];
	  if($escape_gifs&&strtolower($ext)=="gif")
	  {
	  	  $sizes=getimagesize($source);
		  if($sizes[0]<=$xmax&&$sizes[1]<=$ymax)
		  {
		  	$result=copy($source,substr($destination,0,strrpos($destination,'.')).".".strtolower($ext));
			return $result;
		  }
	  }
      if(strtolower($ext) == "jpg" || strtolower($ext) == "jpeg")
	      $im = imagecreatefromjpeg($source);
      else if($ext == "png")
	      $im = imagecreatefrompng($source);
	  else if($ext == "gif")
	      $im = imagecreatefromgif($source);
	  else 
	  	  return false;
	
      $x = @imagesx($im);
      $y = @imagesy($im);
      if($x > $y&&($x > $xmax || $y > $ymax)) 
	  {
	      $newx = $xmax;
	      $newy = $newx * $y / $x;
      }
      else if($x > $xmax || $y > $ymax)
	  {
	      $newy = $ymax;
	      $newx = $x / $y * $newy;
      }
      else
	  {
	  	 
	  	 $newy = $y;
	     $newx = $x;
		
	  }
	  
      $im2 = imagecreatetruecolor($newx, $newy);
      imagecopyresampled($im2, $im, 0, 0, 0, 0, floor($newx), floor($newy), $x, $y);
	  $result=imagejpeg($im2,$destination);
	  imagedestroy($im);
	  imagedestroy($im2);
	  return $result;
}
function SendMail($to,$subject,$body,$html=true,$from="",$cc="")
{
	$from=($from=="")?"no-reply@ecocompass.com":$from;
	$extra_header=($html===true)?"MIME-Version: 1.0\r\nContent-type: text/html; charset=iso-8859-1\r\nFrom: $from":"From: $from";
	@mail($to,$subject,$body,$extra_header);
}
?>