<?php
	$require_user_type = "supplier";
	require "../include/config.php";
	$page_headline = "Product Information";
	require "../include/header_member.php";
	
	$_MANAGER = new ProductsManagement();
	$_CATEGORIES = $_MANAGER->GetAllTypes();
	$_MODE = (isset($_REQUEST["mode"])&&($_REQUEST["mode"]=="add"||$_REQUEST["mode"]=="edit")) ? $_REQUEST["mode"] : "add";

	$prod["id"] = $_POST["id"];
	$prod["brand"] = $_POST["brand"];
	$prod["model"] = $_POST["model"];
	$prod["price"] = $_POST["price"];
	$prod["cat_id"] = $_POST["category"];
	$prod["description"] = $_POST["freeRTE_content"];
	$prod["cat_attributes"] = $_MANAGER->GetCategoryAttributes($_POST["category"]);
	if (is_array($_POST["attr"])) {
		foreach ($prod["cat_attributes"] as $i => $attr) {
			if (isset($_POST["attr"][(int)$attr["id"]]))
				$prod["cat_attributes"][$i]["value"] = $_POST["attr"][(int)$attr["id"]];
		}
	}
	// $prod array is meant to use for "new Row_Instance($prod);", to save the entered values in the inputs

	if ($_POST["mode"]=="add" && $_POST["action"]=="perform")
	{
		if (isset($_POST["category"], $_POST["brand"], $_POST["model"]) && is_numeric($_POST["price"])) {
			$_ERROR = false;
			if (is_array($_POST["attr"]))
				$attributes = $_POST["attr"];
			else
				$attributes = null;
			if (is_array($_POST["feature"]))
				$features = $_POST["feature"];
			else
				$features = null;
			if (!$_MANAGER->CheckMandatoryAttributes($_POST["category"], $attributes)) {
				$_PRODUCT = new Row_Instance($prod);
				$_MESSAGE = "Please fill all the mandatory fields (marked *).";
				$_ERROR = true;			
			} else if (!$_MANAGER->SaveProduct($_POST["id"], $_POST["category"], $_POST["brand"], $_POST["model"], $_POST["price"], $_POST["freeRTE_content"], $attributes, $features)) {
				$_PRODUCT = new Row_Instance($prod);
				$_MESSAGE = "There was an error saving the product, please try again.";
				$_ERROR = true;
			}
			else
				$_MESSAGE = "The product was saved successfully! Now you can add another product.";
		} else {
			$_PRODUCT = new Row_Instance($prod);
			$_MESSAGE = "Please fill all the mandatory fields (marked *).";
			$_ERROR = true;
		}
	}
	else if ($_POST["mode"] == "edit" && $_POST["action"] == "perform" && is_numeric($_POST["id"]))
	{
		$_PRODUCT = $_MANAGER->GetProductInfo($_POST["id"]);
		if (isset($_POST["category"], $_POST["brand"], $_POST["model"]) && is_numeric($_POST["price"])) {
			$_ERROR = false;
			if (is_array($_POST["attr"]))
				$attributes = $_POST["attr"];
			else
				$attributes = null;
			if (is_array($_POST["feature"]))
				$features = $_POST["feature"];
			else
				$features = null;
			if (!$_MANAGER->CheckMandatoryAttributes($_POST["category"], $attributes)) {
				$_PRODUCT = new Row_Instance($prod);
				$_MESSAGE = "Please fill all the mandatory fields (marked *).";
				$_ERROR = true;			
			} else if (!$_MANAGER->UpdateProduct($_POST["id"], $_POST["category"], $_POST["brand"], $_POST["model"], $_POST["price"], $_POST["freeRTE_content"], $attributes, $features)) {
				$_PRODUCT = new Row_Instance($prod);
				$_MESSAGE = "There was an error saving the product, please try again.";
				$_ERROR = true;
			}
			else {
				$_MESSAGE = "The product was saved successfully!";
				$_PRODUCT = $_MANAGER->GetProductInfo($_POST["id"]);
			}
		} else {
			$_PRODUCT = new Row_Instance($prod);
			$_MESSAGE = "Please fill all the mandatory fields (marked *).";
			$_ERROR = true;
		}
	}
	else if ($_GET["mode"] == "edit" && is_numeric($_GET["id"]))
	{
		$_PRODUCT = $_MANAGER->GetProductInfo($_GET["id"]);
		if (!$_PRODUCT) {
			$_MODE = "add";
			// let's generate a temporary unique negative id for this new product
			// so that we can already upload some photos for it
			// and don't lose it after the product is submitted
			$_PRODUCT->id = 0 - $_MANAGER->InitProduct($_SESSION["user_id"]);
		}
	}
	else {
		$_PRODUCT = new Row_Instance($_POST);
		$_PRODUCT->id = 0 - $_MANAGER->InitProduct($_SESSION["user_id"]);
	}
	
	include "includes/server_side/templates/tpl_product_management.php";
	require "../include/footer_member.php";
?>
